//
//  BDSubqueryQualifier.h
//  MCFoundation
//
//  Created by Fraser Kuyvenhoven on 10-05-03.
//  Copyright 2010 Marketcircle Inc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "BDQualifier.h"


@interface BDSubqueryQualifier : BDQualifier <BDQualifierEvaluation, NSCoding>
{
    NSString *_key;
    BDQualifier *_qualifier;
}

+ (id)subqueryQualifierWithKey:(NSString *)key qualifier:(BDQualifier *)qualifier;

- (id)initWithKey:(NSString *)key qualifier:(BDQualifier *)qualifier;

- (NSString*)treeDescription;

- (BOOL)evaluateWithObject:(id)object;

- (NSUInteger)count;
- (NSArray *)subqualifiers;

- (NSString *)key;
- (void)setKey:(NSString *)aKey;

/* NSCoding Protocol */

- (id)initWithCoder:(NSCoder *)coder;
- (void)encodeWithCoder:(NSCoder *)coder;

@end
