/*
 *  DLAttachmentServerDefines.h
 *  DLAttachmentServerTest
 *
 *  Created by Sebastien Boisvert on 2010-05-03 18.
 *  Copyright 2010 Marketcircle, Inc. All rights reserved.
 *
 */

#import <Foundation/Foundation.h>

#pragma mark Bonjour


extern NSString*  kDLAttachmentProtocolName;
extern NSString*  kDLAttachmentProtocolIdentifier;
extern NSString*  kDLAttachmentProtocolVersion;

extern NSString *kDLAttachmentServerServiceType;

// command keys
extern NSString *kDLASAttachmentREADY;
extern NSString *kDLASAttachmentRequest;
extern NSString *kDLASAttachmentReponse;
extern NSString *kDLASAttachmentReceive;
extern NSString *kDLASAttachmentStore;
extern NSString *kDLASAttachmentData;
extern NSString *kDLASTransactionResponse;
extern NSString *kDLASInitTransaction;
extern NSString *kDLASErrorResponse;

// General payload keys
extern NSString *kDLASDatabaseUserKey;
extern NSString *kDLASDatabaseUUIDKey;
extern NSString *kDLASDatabaseNameKey;
extern NSString *kDLASAttachmentIDKey;
extern NSString *kDLASAttachmentObjectLinkTypeKey;
extern NSString *kDLASAttachmentObjectLinkIDKey;
extern NSString *kDLASAttachmentFileNameKey;
extern NSString *kDLASAttachmentFileSizeKey;
extern NSString *kDLASAttachmentImageDimensionsKey;
extern NSString *kDLASAttachmentFileCreateDateKey;
extern NSString *kDLASAttachmentFileModifyDateKey;
extern NSString *kDLAttachmentIsInlineImageKey;
extern NSString *kDLAttachmentIconImageKey;
extern NSString *kDLAttachmentErrorKey;

extern NSString *kDLAttachmentServerDomain;

typedef enum {
	kDLAttachmentTransferErrorNone = 0,
	kDLAttachmentTransferErrorWarning,
	kDLAttachmentTransferErrorCritical
} DLAttachmentTransferErrorType;

// error codes

typedef enum {
	kDLAttachmentDatabaseConnectionError = 100,
	kDLAttachmentDatabaseMismatch = 101,
	kDLAttachmentNoAttachment = 200,
	kDLAttachmentNoData = 201,
	kDLAttachmentRetrieveError = 300,
	kDLAttachmentStoreError = 301,
	kDLAttachmentCachingError = 400,
	kDLAttachmentCachingSaveError = 401,
	kDLAttachmentNoSchemeError = 500,
	kDLAttachmentIsFileReferenceError = 600,
	kDLAttachmentArchiverPathNotFound = 700,
	kDLAttachmentRemoteAttachmentRetreiveError = 800, // generic error for remote retreivals
	kDLAttachmentRemoteAttachmentFileInaccessibleError = 900,
	kDLAttachmentRemoteAttachmentFolderOrBundleError = 901

} DLAttachmentServerError;

#pragma mark Error Strings

extern NSString* kDLFileNotFoundOnServerString;
extern NSString* kDLFileDataMissingString;
extern NSString* kDLCouldNotConnectString;
extern NSString* kDLLostConnectionString;
extern NSString* kDLCouldNotGetFileReferenceString;
extern NSString* kDLCouldNotGetArchivedFileString;
extern NSString* kDLCouldNotRetreiveRemoteAttachmentString;
extern NSString* kDLCouldNotRetreiveRemoteFileInaccessibleString;
extern NSString* kDLCouldNotRetreiveRemoteFolderOrBundleString;

@interface DLAttachmentServerLocalizations : NSObject
@end

