//
//  DLLinkingPopoverView.h
//  DLViews
//
//  Created by Jordan Valadas on 11-08-08.
//  Copyright (c) 2011 Marketcircle Inc. All rights reserved.
//

#import "DLPObjectContext.h"

@class DLLinkingResultsView;
@class DLQuickSearchTableView;
@class DLLinkingField;
@class DLLinkingDataSource;
@class DLPObjectContext;

@protocol DLLinkingPopoverDataSource

@property(nonatomic, weak) DLPObjectContext *objectContext;

- (NSArray *)queryItems;
- (NSString *)searchTitle;

@end

@interface DLLinkingPopoverView : MCNibLoadingView <NSPopoverDelegate>
{
	IBOutlet DLLinkingResultsView *resultsView;
	IBOutlet NSTextField *searchField;
    IBOutlet NSTextField *titleField;
	IBOutlet NSProgressIndicator *progressIndicator;
	
	IBOutlet NSBox *topLine;
	IBOutlet NSBox *bottomLine;
    
	NSWindow *linkingFieldWindow;
	DLLinkingField *linkingField;
	
	NSPopover *linkingPopover;
	
	NSView *accessoryView;
	BOOL showsAccessoryView;
}

@property(nonatomic,strong) NSView *accessoryView;
@property(nonatomic,assign) BOOL showsAccessoryView;
@property(nonatomic,strong) NSString *title; // appears above the search field in bold.

@property (readonly) DLLinkingResultsView *resultsView;

@property (nonatomic,readonly,strong) id delegate;
@property (nonatomic,readonly,strong) id <DLLinkingPopoverDataSource>dataSource;

@property (readonly) NSArray *allowedNewObjectEntityNames;

+ (DLLinkingPopoverView *)sharedController;
- (void)displayLinkingPopoverForDelegate:(id)aDelegate 
                              dataSource:(id <DLLinkingPopoverDataSource>)aDataSource
                     initialSearchString:(NSString *)aString
                                   title:(NSString *)aTitle
                                hostView:(NSView *)aHostView 
                           preferredEdge:(NSRectEdge)preferredEdge;

- (IBAction)closeLinkingWindow:(id)sender;

- (void)linkNewObjectForEntityNamed:(NSString *)anEntityName;

@end
