//
//  DLPObjectContext+CreationConveniences.h
//  DLSubstrate
//
//  Created by Ali Lalani on 11-05-17.
//  Copyright 2011 Marketcircle Inc. All rights reserved.
//

#import "DLPObjectContext.h"

typedef enum {
    kDLProjectFromOpportunityLinkContactsAndOrgs = 0x01,
    kDLProjectFromOpportunityLinkNotesAndEmails = 0x02,
    kDLProjectFromOpportunityLinkTasks = 0x04,
    kDLProjectFromOpportunityLinkTimeblocks = 0x08,
    kDLProjectFromOpportunityLinkForms = 0x16,
    
} DLProjectFromOpportunityLinkOptions;

@class GWProject,GWOpportunity,GWCustomRecordSetDefinition,GWCustomRecordSet, GWFileAttachment;

@interface DLPObjectContext (CreationConveniences)

- (GWProject *)newProjectFromOpportunity:(GWOpportunity *)anOpportunity projectName:(NSString *)aName linkOptions:(DLProjectFromOpportunityLinkOptions)linkOptions;

- (GWCustomRecordSet *)createCustomRecordSetForCustomRecordSetDefinition:(GWCustomRecordSetDefinition *)aCustomRecordSetDefinition;

#if ! TARGET_OS_IPHONE

#pragma mark File Attachment Creation

-(GWFileAttachment *)createFileAttachmentFromFileURL:(NSURL*)fileURL;
-(GWFileAttachment *)createFileReferenceFromFileURL:(NSURL*)fileURL;

#endif

@end
