//
//  DLPObjectContext+DataShortcuts.h
//  DLSubstrate
//
//  Created by Michael Clark on 11-03-08.
//  Copyright 2011 Marketcircle, Inc. All rights reserved.
//

#import "DLPObjectContext.h"

@class BDQualifier;
@class GWSourceList,GWContact,GWCategory;

@interface DLPObjectContext (DataShortcuts)

@property(nonatomic,readonly) NSString *tax1Name;
@property(nonatomic,readonly) NSString *tax2Name;
@property(nonatomic,readonly) BOOL tax1Enabled;
@property(nonatomic,readonly) BOOL tax2Enabled;
@property(nonatomic,readonly) BOOL tax2IsCompound;

#pragma mark -
#pragma mark Contacts
- (NSArray *)contactPriorityEnumWrappers;

- (GWContact *)contactWithFirstname:(NSString *)first lastname:(NSString *)last emailAddress:(NSString *)email createIfNotFound:(BOOL)create;

#pragma mark -
#pragma mark Category
- (GWCategory *)categoryNamed:(NSString *)aName forObjectWithClass:(Class)anObjClass createIfNotFound:(BOOL)create;


#pragma mark -
#pragma mark Organizations
- (NSArray *)organizationPriorityEnumWrappers;

#pragma mark -
#pragma mark Projects
- (NSArray *)projectStatusEnumWrappers;
- (NSArray *)projectPriorityEnumWrappers;
- (NSArray *)openProjectsForContactOrOrganization:(id)aContactOrOrg;

#pragma mark -
#pragma mark Opportunities
- (NSArray *)opportunityPriorityEnumWrappers;
- (NSArray *)opportunityStateEnumWrappers;
- (NSArray *)openOpportunitiesForContactOrOrganization:(id)aContactOrOrg;

#pragma mark -
#pragma mark Groups
#if !TARGET_OS_IPHONE
- (NSArray *)groupPriorityEnumWrappers;
#endif

#pragma mark -
#pragma mark Tasks
- (NSArray *)taskStatusEnumWrappers;
- (NSArray *)taskTypeEnumWrappers;
- (NSArray *)taskPriorityEnumWrappers;

#pragma mark -
#pragma mark Timeblocks
- (NSArray *)timeblockTypeEnumWrappers;
- (NSArray *)timeblockStatusEnumWrappers;

#pragma mark -
#pragma mark Notes
- (NSArray *)noteTypeEnumWrappers;

#pragma mark -
#pragma mark LineItems
- (NSArray *)lineItemTypeEnumWrappers;

#pragma mark -
#pragma mark Pipelines
- (NSArray *)pipelines;
- (NSArray *)activeOpportunityPipelines;
- (NSArray *)activeProjectPipelines;

#pragma mark -
#pragma mark ElectronicAddresses
- (NSArray *)electronicAddressProviderEnumWrappers;
- (NSArray *)electronicAddressLabelTypeEnumWrappers;

#pragma mark -
#pragma mark Date Component Enum Wrappers
- (NSArray *)monthOfYearEnumWrappers;
- (NSArray *)dayOfMonthEnumWrappers;

#pragma mark FieldOptions
- (NSArray *)locationFieldOptionValues;

#pragma mark DLTimeblockDataSource
- (NSArray *)timeblocksFromDate:(NSDate *)startDate toDate:(NSDate *)endDate forUsers:(NSArray *)users resources:(NSArray *)resources additionalQualifier:(BDQualifier *)aQualifier;

@end
