//
//  DLPObjectContext+Delegation.h
//  DLSubstrate
//
//  Created by Ali Lalani on 11-07-05.
//  Copyright 2011 Marketcircle Inc. All rights reserved.
//

#import "DLPObjectContext.h"
#import "DLDelegatableObject.h"

@interface DLPObjectContext (Delegation)

- (void)recordNotifyChangesToObject: (DLPObject <DLDelegatableObject>*)object;
- (void)notifyChangesOnObject: (DLPObject <DLDelegatableObject> *)object;

- (void)delegateObject:(id)anObject toUser:(GWUser *)delegateUser withNote:(NSString *)aNote notifyUserOfChanges:(BOOL)notify;

- (BOOL)user:(GWUser*)aUser isaDelegateOfObject:(id)anObject;

- (void)notifyDelegatesOfChanges: (NSDictionary*)changes toObject: (id)object byUser: (GWUser*)changingUser;
- (void)notifyForDeletionOfObject:(id)object byUser:(GWUser*)user;

#pragma mark Conveniences
// An array of users to be notified of changes, minus the user who is making the changes (since they obviously do not need to be notified)
- (NSArray *)delegateUsersToNotifyOfChangesForObject:(id)anObject changingUser:(GWUser *)changingUser;

- (BOOL)shouldNotifyUser:(GWUser *)aUser ofChangesToObject:(id)anObject;
- (void)setShouldNotify:(BOOL)notify forUser:(GWUser *)aUser ofChangesToObject:(id)anObject;

@end
