//
//  DLPObjectContext+Linking.h
//  GWSubstrate
//
//  Created by Oscar Perez on 11-01-28.
//  Copyright 2011 Marketcircle. All rights reserved.
//

#import "DLPObjectContext.h"

typedef enum {
    kDLLinkTypeStandard     = 0,
    kDLLinkTypeRole         = 1,
    kDLLinkTypeRelationship = 2,
} DLLinkType;

@class GWRole,GWRelationship,GWRoleType,GWUser;
@class MCPEntity;


@interface DLPObjectContext (Linking)

+ (DLLinkType)linkTypeForObject:(id)obj1 andObject:(id)obj2;

- (BOOL)isRoleBasedLinkFromEntity:(MCPEntity *)entity1 toEntity:(MCPEntity *)entity2;
- (BOOL)isRelationshipBasedLinkFromEntity:(MCPEntity *)entity1 toEntity:(MCPEntity *)entity2;


- (void)linkObjects: (NSArray *)sourceObjects toObject: (id)targetObject;
- (void)linkObject: (id)sourceObject toObject: (id)targetObject;

- (void)linkObjects: (NSArray*)sourceObjects toObject: (id)targetObject withRoleType: (GWRoleType*)roleType;
- (void)linkObjects: (NSArray*)sourceObjects toObject: (id)targetObject withRoleType: (GWRoleType*)roleType postNotification:(BOOL)flag;
- (GWRole*)linkObject: (id)sourceObject toObject: (id)targetObject withRoleType: (GWRoleType*)roleType;
- (GWRole *)linkObject: (id)source toObject:(id)target withRoleType:(GWRoleType *)roleType postNotification:(BOOL)flag;
- (void)linkObject: (id)source toObject:(id)target withRole:(GWRole *)role;

- (void)linkObject:(id)source toObject:(id)target withRelationship:(GWRelationship *)relationship;


- (void)unlinkObjects: (NSArray *)sourceObjects fromObject: (id)targetObject;
- (void)unlinkObject: (id)sourceObject fromObject: (id)targetObject;

// Intermediary Objects
- (void)unlinkObject: (id)sourceObject fromObject:(id)targetObject withRole:(GWRole *)aRole;
- (void)unlinkObject: (id)sourceObject fromObject:(id)targetObject withRelationship:(GWRelationship *)rel;


@end
