//
//  DLPObjectContext+SourceList.h
//  DLSubstrate
//
//  Created by Fraser Kuyvenhoven on 2011-04-27.
//  Copyright 2011 Marketcircle Inc. All rights reserved.
//

#import "DLPObjectContext.h"

@class GWSourceList;
@class DLSearchCriteria;
@class GWTask;
@class GWUser;
@class GWContact, GWOrganization;

extern NSString *kDLShareAllContactsDidChangeNotification;

@interface DLPObjectContext (SourceList)

- (NSArray *)sourceListsForUser:(GWUser*)aUser;
- (NSArray *)sourceListsForEntityNamed:(NSString *)anEntityName;

#pragma mark Creation

- (GWSourceList *)createDumbListForEntityNamed:(NSString *)anEntityName;
#if !TARGET_OS_IPHONE
- (GWSourceList *)createSmartListForEntityNamed:(NSString *)anEntityName;
#endif
- (GWSourceList *)createSmartListWithCriteria:(DLSearchCriteria *)aCriteria;

#pragma mark System Lists

- (GWSourceList *)taskInboxSourceListForUser:(GWUser *)aUser;
- (GWSourceList *)taskInboxSourceListForUser:(GWUser *)aUser cleanupAsynchronous:(BOOL)cleanupAsynchronous;
- (GWSourceList *)taskWorklistSourceList;
- (BOOL)isTaskInWorklist:(GWTask *)aTask;
- (void)addTaskToWorklist:(GWTask *)aTask;
- (void)removeTaskFromWorklist:(GWTask *)aTask;

- (GWSourceList *)taskUnfiledSourceListForUser:(GWUser *)aUser;
- (GWSourceList *)taskUnfiledSourceList;
- (BOOL)isTaskInUnfiledList:(GWTask *)aTask;
- (void)addTaskToUnfiledList:(GWTask *)aTask;
- (void)removeTaskFromUnfiledList:(GWTask *)aTask;

- (GWSourceList *)taskWorklistSourceListForUser:(GWUser*)aUser;
- (GWSourceList *)taskInboxSourceList;
- (BOOL)isTaskInboxList:(GWTask *)aTask;
- (void)addTaskToInboxList:(GWTask *)aTask;
- (void)removeTaskFromInboxList:(GWTask *)aTask;

#pragma mark Last Import Dumblist

- (GWSourceList*)lastImportForEntityNamed:(NSString *)anEntityName;
- (GWSourceList *)createLastImportIfNeededForEntityNamed:(NSString *)anEntityName;

#pragma mark Touch Sync System Lists

- (GWSourceList*)contactTouchSyncList;
- (BOOL)isContactInContactTouchSyncList: (GWContact*)aContact;
- (void)addContactToContactTouchSyncList: (GWContact*)aContact;
- (void)removeContactFromContactTouchSyncList: (GWContact*)aContact;

- (GWSourceList*)organizationTouchSyncList;
- (BOOL)isOrganizationInOrganizationTouchSyncList: (GWOrganization*)anOrg;
- (void)addOrganizationToOrganizationTouchSyncList: (GWOrganization*)anOrg;
- (void)removeOrganizationFromOrganizationTouchSyncList: (GWOrganization*)anOrg;

@end
