//
//  DLQuickSearchEntityQueryItem+DefaultItems.h
//  DLViews
//
//  Created by Fraser Kuyvenhoven on 2012.08.07.
//  Copyright (c) 2012 Marketcircle Inc. All rights reserved.
//

#import "DLQuickSearchEntityQueryItem.h"

@class DLPObjectContext;


@interface DLQuickSearchEntityQueryItem (DefaultItems)

+ (DLQuickSearchEntityQueryItem *)contactAndUserQueryItemWithObjectContext:(DLPObjectContext *)anObjectContext;
+ (DLQuickSearchEntityQueryItem *)contactQueryItemWithObjectContext:(DLPObjectContext *)anObjectContext;
+ (DLQuickSearchEntityQueryItem *)userQueryItemWithObjectContext:(DLPObjectContext *)anObjectContext;
+ (DLQuickSearchEntityQueryItem *)organizationQueryItemWithObjectContext:(DLPObjectContext *)anObjectContext;
+ (DLQuickSearchEntityQueryItem *)projectQueryItemWithObjectContext:(DLPObjectContext *)anObjectContext;
+ (DLQuickSearchEntityQueryItem *)opportunityQueryItemWithObjectContext:(DLPObjectContext *)anObjectContext;
+ (DLQuickSearchEntityQueryItem *)timeblockQueryItemWithObjectContext:(DLPObjectContext *)anObjectContext;
+ (DLQuickSearchEntityQueryItem *)taskQueryItemWithObjectContext:(DLPObjectContext *)anObjectContext;
+ (DLQuickSearchEntityQueryItem *)noteQueryItemWithObjectContext:(DLPObjectContext *)anObjectContext;
+ (DLQuickSearchEntityQueryItem *)emailQueryItemWithObjectContext:(DLPObjectContext *)anObjectContext;
+ (DLQuickSearchEntityQueryItem *)formQueryItemWithObjectContext:(DLPObjectContext *)anObjectContext;
+ (DLQuickSearchEntityQueryItem *)groupQueryItemWithObjectContext:(DLPObjectContext *)anObjectContext;

#pragma mark Search Specs

- (void)addDefaultContactSearchSpecs;
- (void)addDefaultOrganizationSearchSpecs;
- (void)addDefaultProjectSearchSpecs;
- (void)addDefaultOpportunitySearchSpecs;
- (void)addDefaultTimeblockSearchSpecs;
- (void)addDefaultTaskSearchSpecs;
- (void)addDefaultNoteSearchSpecs;
- (void)addDefaultEmailSearchSpecs;
- (void)addDefaultFormSearchSpecs;
- (void)addDefaultGroupSearchSpecs;

- (void)addDefaultContactNameSearchSpecs;
- (void)addDefaultContactNameSearchSpecsWithAdditionalQualifier:(BDQualifier *)aQualifier;
- (void)addDefaultContactOtherSearchSpecs;

#pragma mark Qualifiers

+ (BDQualifier *)activeUsersQualifier;
+ (BDQualifier *)contactsAndInactiveUsersQualifier;

@end
