//
//  DLQuickSearchQueryItem.h
//  DLQuickSearchTest
//
//  Created by Ali Lalani on 10-02-08.
//  Copyright 2010 Marketcircle, Inc. All rights reserved.
//
/*
 This class encapsulates the results of a query group.
 */

#import <Foundation/Foundation.h>

#import "DLQuickSearchQueryItemSearchSpec.h"

@class NSImage;


@interface DLQuickSearchQueryItem : NSObject {
    NSString *title;
    NSImage *icon;
    NSImage *iconSelected;
    NSString *searchString;
    NSString *displayKeyPath;
    NSString *identifier;
    
    NSMutableArray *results;
    
    BOOL active;
    BOOL isExecutingQuery;
}
@property(nonatomic,strong) NSString *title;
@property(strong) NSImage *icon;
@property(strong) NSImage *iconSelected;
@property(strong) NSString *searchString;
@property(strong) NSString *displayKeyPath;
@property(strong) NSString *identifier;
@property(strong) NSMutableArray *searchSpecs;

@property(strong) NSMutableArray *results;

@property(assign) BOOL active;
@property(assign) BOOL isExecutingQuery;

- (id)initWithIdentifier:(NSString *)anIdentifier displayKeyPath:(NSString *)aDisplayKeyPath;

- (void)addSearchSpec:(DLQuickSearchQueryItemSearchSpec *)aSearchSpec;

- (NSArray *)allResults;

// Subclassers must implement this, as they will be responsible for managing their own set of "queries", whether that be
// database queries or something else.
// returns nil if there is no query. If no results, returns an empty array.
- (void)executeNextQueryAndNotify:(void (^)(NSArray *results, DLQuickSearchQueryItemSearchSpec *searchSpec))block;

- (BOOL)hasNextQuery;
- (DLQueryItemSearchSpecPriority)nextQueryPriority;
- (void)clearRemainingQueries;

- (void)reset;

- (void)addQueryResults:(NSArray *)aQueryResults;

@end

