// GWFileAttachment.h
// GWSubstrate
//
// Copyright (c) 2001 Marketcircle Inc. All rights reserved.


#import "_GWFileAttachment.h"

extern NSString *kGWFileAttachmentSchemeNamesKey;

@interface GWFileAttachment : _GWFileAttachment
{
@private
    BOOL _didCreate; // used as a flag when we first create the object; this is so we know to go ahead and store/cache the attachment in the database;
}

@property (strong,readwrite) NSURL *temporaryPath;
@property (strong,nonatomic,readwrite) id linkedObject;
@property (weak) id delegate;
@property(nonatomic,readonly) NSString *displayName;

-(NSURL*)saveAttachmentToURL:(NSURL*)saveURL;
-(NSURL *)cachedURL;
-(BOOL)retrieveAttachmentWithDelegate:(id)delegate error:(NSError **)error;

-(BOOL)storeAttachmentWithError:(NSError **)error;

#if ! TARGET_OS_IPHONE
-(void)setFileAttachmentAttributesFromFileURL:(NSURL*)fileURL;
#endif

-(void)updateMissingDetailsFromURL:(NSURL *)fromURL;

@end
