// GWKeyword.h
// GWSubstrate
// 
// Copyright (c) 2001 Marketcircle Inc. All rights reserved.


#import "_GWKeyword.h"


typedef enum
{
	GWKeywordObjectTypeContact,
	GWKeywordObjectTypeOrganization,
	GWKeywordObjectTypeOpportunity,
	GWKeywordObjectTypeProject,
	GWKeywordObjectTypeTask,
	GWKeywordObjectTypeTimeblock,
	GWKeywordObjectTypeNote,
	GWKeywordObjectTypeEmail,
	GWKeywordObjectTypeCustomRecordSet,
	GWKeywordObjectTypeGroup
} GWKeywordObjectType;


@interface GWKeyword : _GWKeyword 
{
}

- (id)isActiveForFilter;
- (id)isActiveForContactFilter;
- (id)isActiveForOrganizationFilter;
- (id)isActiveForProjectFilter;
- (id)isActiveForOpportunityFilter;
- (id)isActiveForTaskFilter;
- (id)isActiveForTimeblockFilter;
- (id)isActiveForNoteFilter;
- (id)isActiveForEmailFilter;
- (id)isActiveForCustomRecordSetFilter;
- (id)isActiveForGroupFilter;

- (BOOL)activeBool;
- (BOOL)forProjectBool;
- (BOOL)forOrganizationBool;
- (BOOL)forOpportunityBool;
- (BOOL)forContactBool;
- (BOOL)forTaskBool;
- (BOOL)forTimeblockBool;
- (BOOL)forNoteBool;
- (BOOL)forEmailBool;
- (BOOL)forCustomRecordSetBool;
- (BOOL)forGroupBool;
- (BOOL)forNoneBool;

- (void)setForObjectType:(GWKeywordObjectType)objectType;
- (void)setForOnlyObjectType:(GWKeywordObjectType)objectType;

+ (NSPredicate *)predicateForObjectType:(GWKeywordObjectType)objectType;
+ (GWKeywordObjectType)objectTypeForEntityName:(NSString *)anEntityName;

- (BOOL)appliesToSubsetOrEqualToKeyword:(GWKeyword*)aKeyword;

- (NSInteger)numOfActiveForEntity;
- (BOOL)canDeleteForEntityNamed:(NSString*)entName;
- (void)verifyValidAppliesTo;

- (BOOL)enabledForEntityNamed:(NSString*)entName;
- (BOOL)enabledForProject;
- (BOOL)enabledForOrganization;
- (BOOL)enabledForOpportunity;
- (BOOL)enabledForContact;
- (BOOL)enabledForTask;
- (BOOL)enabledForTimeblock;
- (BOOL)enabledForNote;
- (BOOL)enabledForEmail;
- (BOOL)enabledForCustomRecordSet;
- (BOOL)enabledForGroup;

@end
