//
//  GWSubstrateDefines.h
//  GWSubstrate
//
//  Created by Alykhan Jetha on Sun Aug 31 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//


#import "MCPDefines.h"


// Daylite Path Conveniences
// ~/Library/Application Support/com.marketcircle.Daylite4
extern NSString* DLUserAppSupportFolder(void);
// /Library/Application Support/com.marketcircle.Daylite4
extern NSString* DLLocalAppSupportFolder(void);

// ~/Library/Caches/com.marketcircle.Daylite4
extern NSString* DLUserCachesFolder(void);

#define kGWPrimaryKeyIncrementOffset 1000


#pragma mark -
#pragma mark HTTP Realm
// Used for password generation
extern NSString* kDLSHTTPRealm;


extern NSString	*MCReminderDidChangeNotification;
extern NSString *MCReminderDeletedNotification;
extern NSString *GWRemindersGoingAwayNotification;
extern NSString *GWRefreshedCurrentUserCalendarNotification;


extern NSString *MCRepeatRuleWeeklyDidChangeNotification;

extern	NSString	*GWCategoryContainerDidAddNotification;
extern	NSString	*GWCategoryContainerWillRemoveNotification;


// useful when color changes ...
extern	NSString	*GWCategoryDidChangeNotification;


extern	NSString	*GWProjectContainerDidAddNotification;
extern	NSString	*GWProjectContainerWillRemoveNotification;

// listen to this notification when interesting in knowing when a new major objects (i.e. contact, org, opp ...) has been added
// the object on the notification is the added model object
extern 	NSString	*GWAddedMajorObjectNotification;

extern NSString* GWUserAddedNotification;


extern	NSString	*GWContactPBoardType;
extern  NSString    *GWContactPtrPBoardType;
extern	NSString	*GWTaskPBoardType;
extern	NSString	*GWTaskPtrPBoardType;
extern	NSString	*GWOrganizationPBoardType;
extern	NSString	*GWOrganizationPtrPBoardType;

extern	NSString	*GWGroupPBoardType;
extern	NSString	*GWOpportunityPBoardType;
extern	NSString	*GWProjectPBoardType;

extern  NSString	*GWCustomRecordDefinitionPBoardType;
extern	NSString	*GWUserPBoardType;

extern NSString     *GWPhonePBoardType;
extern NSString     *GWElectronicAddressPBoardType;


extern NSString     *GWContactCreationPermissionMask;
extern NSString     *GWOrganizationCreationPermissionMask;
extern NSString     *GWGroupCreationPermissionMask;
extern NSString     *GWOpportunityCreationPermissionMask;
extern NSString     *GWProjectCreationPermissionMask;

extern NSString     *GWPersonalNoteCreationPermissionMask;
extern NSString     *GWTaskCreationPermissionMask;
extern NSString     *GWTimeblockCreationPermissionMask;

extern NSString     *GWSubstrateErrorDomain;

// User Defaults Keys
extern NSString     *GWAutoLinkContactTimeblocksToDefaultOrgUserDefaultsKey;
extern NSString     *GWAutoLinkContactNotesAndEmailsToDefaultOrgUserDefaultsKey;
extern NSString     *GWAutoLinkContactTasksToDefaultOrgUserDefaultsKey;
extern NSString     *GWAutoLinkContactObjectivesToDefaultOrgUserDefaultsKey;

extern NSString *kMCUsePrimaryTaxUserDefaultsKey;
extern NSString *kMCUseSecondaryTaxUserDefaultsKey;
extern NSString *kMCUseCompoundSecondaryTaxUserDefaultsKey;
extern NSString *kMCPrimaryTaxNameUserDefaultsKey;
extern NSString *kMCSecondaryTaxNameUserDefaultsKey;
extern NSString *kMCPrimaryTaxRateUserDefaultsKey;
extern NSString *kMCSecondaryTaxRateUserDefaultsKey;

extern NSString *kDLPhoneNumberFormattingEnabledDefaultsKey;
extern NSString *kDLPhoneNumberFormatStringDefaultsKey;
extern NSString *kDLPhoneNumberFormatExtensionDelimitersDefaultsKey;


extern NSString     *GWEnableModelPermissionsSystem;

extern NSString *kDLEmailContentEditableUserDefaultsKey;

extern NSString *kDLShareAllContactsUserDefaultsKey;

extern NSString *kDLDetailEditOverridesDefaultsKey;

typedef enum {
    DLBoolFALSE,
    DLBoolTRUE,
    DLBoolEITHER
} DLThreeStateBoolean;

typedef enum _GWObjectType {
    GWRootObject				= 2000,
    GWCalendarObject			= 2001,
    GWTaskObject				= 2002,
    GWContactObject				= 2003,
    GWNoteObject				= 2004,
    GWURLReferenceObject		= 2005,
    GWProjectObject				= 2006,
    GWGroupObject				= 2007,
    GWCategoryObject			= 2008
} GWObjectType;




typedef enum _GWContactSalutation {
    GWContactSalutationOther	= 0,
    GWContactSalutationMs		= 1,
    GWContactSalutationMiss		= 2,
    GWContactSalutationMrs		= 3,
    GWContactSalutationMr		= 4,
    GWContactSalutationDr		= 5
} GWContactSalutation;


typedef enum _GWElectronicAddressType {
    GWElectronicAddressOther				= 0,
    GWElectronicAddressEmail				= 1,
    GWElectronicAddressInstantMessenging	= 2,
    GWElectronicAddressMobileMessenging		= 3,
    GWElectronicAddressWebSite				= 4
} GWElectronicAddressType;


typedef enum _GWGeoAddressType {
    GWGeoAddressOther		= 0,
    GWGeoAddressBusiness	= 1,
    GWGeoAddressHome		= 2,
    GWGeoAddressBilling		= 3,
    GWGeoAddressShipping	= 4
} GWGeoAddressType;


typedef enum _GWPhoneType {
    GWPhoneOther		= 0,
    GWPhoneBusiness		= 1,
    GWPhoneHome			= 2,
    GWPhoneMobile		= 3,
    GWPhonePager		= 4,
    GWPhoneFax			= 5
} GWPhoneType;


typedef enum _GWURLReferenceType {
    GWURLReferenceOther		= 0, // depecrated
    GWURLReferenceWeb		= 1,
    GWURLReferenceFile		= 2  // depecrated
} GWURLReferenceType;


typedef enum _GWTaskStatus {
    GWTaskStatusOpen			= 0,
    GWTaskStatusPending         = 4,
    GWTaskStatusDeferred        = 5,
    GWTaskStatusInProgress		= 6,
    GWTaskStatusDone			= 7,
    GWTaskStatusCancelled		= 8,
} GWTaskStatus;

typedef enum _GWTaskType {
    GWTaskTypeToDo = 0,
    GWTaskTypeInboundCall = 1,
    GWTaskTypeOutboundCall = 2,
    GWTaskTypeFax = 3,
    GWTaskTypeEmail = 4,
    GWTaskTypeMail = 5,
    GWTaskTypePrint = 6
} GWTaskType;

typedef enum _GWReminderUnit {
    GWReminderUnitMinutes		= 0,
    GWReminderUnitHours			= 1,
    GWReminderUnitDays			= 2,
    GWReminderUnitMinutesAfter  = 3,
    GWReminderUnitHoursAfter    = 4,
    GWReminderUnitDaysAfter     = 5,
    GWReminderOnDateTime     = 6,
    GWReminderTaskSameDay     = 7
} GWReminderUnit;


typedef enum _GWOpportunityState {
    GWOpenOpportunityState			= 0,
    GWWonOpportunityState			= 1,
    GWSuspendedOpportunityState		= 2,
    GWAbandonedOpportunityState		= 3,
    GWLostOpportunityState			= 4
} GWOpportunityState;

typedef enum _GWProjectStatus {
    GWProjectInProgressStatus = 0,
    GWProjectDeferredStatus = 1,
    GWProjectCancelledStatus = 2,
    GWProjectAbandonedStatus = 3,
    GWProjectNewStatus = 4,
    GWProjectDoneStatus = 7
} GWProjectStatus;

typedef NS_ENUM (NSInteger, GWCustomFieldDefinitionType) {
    GWCustomFieldDefinitionWordType			= 0,
    GWCustomFieldDefinitionNumberType		= 1,
    GWCustomFieldDefinitionDateType			= 2,
    GWCustomFieldDefinitionTimeType			= 3,
    GWCustomFieldDefinitionDateTimeType		= 4,
    GWCustomFieldDefinitionFloatType		= 5,
    GWCustomFieldDefinitionMoneyType		= 6,
    GWCustomFieldDefinitionOptionType		= 7,
    GWCustomFieldDefinitionComboType        = 8,
    GWCustomFieldDefinitionCheckboxType     = 9,
    GWCustomFieldDefinitionCheckboxMatrixType = 10
};

typedef enum _GWReminderICalAlarmType {
    GWReminderICalDisplayType = 0,
    GWReminderICalEmailType   = 1,
    GWReminderICalSoundType   = 2,
} GWReminderICalAlarmType;

// for new-style reminders for 3.8 up
typedef enum _GWReminderDayliteReminderType {
    GWReminderDayliteDisplayType = 1,
    GWReminderDayliteEmailType,
    GWReminderDayliteSoundType,
    GWReminderDayliteRunScriptType,
    GWReminderDayliteOpenFileType,
    GWReminderDayliteSpeakTextType,
    GWReminderDayliteDisplayNoteType
} GWReminderDayliteReminderType;

typedef enum _GWTaskPriority {
    GWNoPriority            = 0,
    GWHighPriority			= 1,
    GWMediumPriority		= 2,
    GWLowPriority			= 3,
} _GWTaskPriority;

typedef enum _GWEnvelopeTemplateType {
    GWEnvelopeTemplateContactType          = 1,
    GWEnvelopeTemplateOrganizationType     = 2
} GWEnvelopeTemplateType;

typedef enum _GWLabelTemplateType {
    GWLabelTemplateContactType          = 0,
    GWLabelTemplateOrganizationType     = 1
} GWLabelTemplateType;

typedef enum _DLTaskWorklistClearType {
    DLTaskWorklistClearImmediately = 0,
    DLTaskWorklistClearDaily
} DLTaskWorklistClearType;


typedef enum _GWPalmSyncMapType {
    GWPalmSyncMapContactType          = 1,
    GWPalmSyncMapTimeblockType,
    GWPalmSyncMapTaskType,
    GWPalmSyncMapNoteType,
    GWPalmSyncMapOrganizationType
} GWPalmSyncMapType;

typedef enum _GWABSyncMapType {
    GWABSyncMapContactType          = 1,
    GWABSyncMapOrganizationType
} GWABSyncMapType;

typedef enum _GWABSyncConflictResType {
    GWABSyncDLTakesPrecedence = 1,
    GWABSyncRememberDLTakesPrecedence,
    GWABSyncABTakesPrecedence,
    GWABSyncRememberABTakesPrecedence
} GWABSyncConflictResType;

typedef enum _GWABSyncDeleteResType {
    GWABSyncPropagateDelete = 1,
    GWABSyncRememberPropagateDelete,
    GWABSyncDontPropagateDelete,
    GWABSyncRememberDontPropagateDelete,
    GWABSyncRecreateInAB,
    GWABSyncRememberRecreateInAB
} GWABSyncDeleteResType;

typedef enum _GWNoteType {
    GWNormalNoteType          		= 0,
    GWSyncNoteType					= 10
} GWNoteType;

// User last sync types
typedef enum _GWUserLastSyncType {
    AddressBookSyncType        = 0,
    PalmContactSyncType        = 1,
    PalmCalendarSyncType       = 2,
    PalmToDoSyncType           = 3,
    PalmMemoSyncType           = 4
} GWUserLastSyncType;

// product/service defines
enum _GWProductServiceTypeCode
{
    GWPRODUCTSERVICE_TYPE_CUSTOM = 1,
    GWPRODUCTSERVICE_TYPE_PRODUCT = 2,
    GWPRODUCTSERVICE_TYPE_SERVICE = 3
} GWProductServiceTypeCode;

enum _GWProductServiceDiscountTypeCodeE
{
    GWPRODUCTSERVICE_DISCOUNT_TYPE_PERCENT = 1,
    GWPRODUCTSERVICE_DISCOUNT_TYPE_DOLLAR = 2
} GWProductServiceDiscountTypeCode;

enum _GWProductServiceMarkupTypeCode
{
    GWPRODUCTSERVICE_MARKUP_TYPE_PERCENT = 1,
    GWPRODUCTSERVICE_MARKUP_TYPE_DOLLAR = 2
} GWProductServiceMarkupTypeCode;


// DEPRECATED DEFINES - RepeatRule is no more
typedef enum _GWRepeatRuleType {
    GWRepeatRuleDay             = 0,
    GWRepeatRuleWeek		= 1,
    GWRepeatRuleMonth		= 1,// should be 2
    GWRepeatRuleYear		= 2//should be 3
} GWRepeatRuleType;

typedef enum _GWRepeatMonthDayOrDate {
    GWRepeatMonthDay		= 0,
    GWRepeatMonthDate		= 1
} GWRepeatMonthDayOrDate;



///// END - REPEAT DEFINES /////


typedef enum _GWRoleTypeAppliesToTypeCode {
    GWRoleType_AppliesToContact = 0,
    GWRoleType_AppliesToOrganization = 1
} GWRoleTypeAppliesToTypeCode;

typedef enum _GWDefaultVisibilityTag
{
    GWVISIBILITY_DEFAULT_PUBLIC = 1,
    GWVISIBILITY_DEFAULT_PRIVATE = 2
} GWDefaultVisibilityTag;


// SYNC SERVICES TYPE DEFINES

typedef NS_ENUM(NSInteger, GWSyncTypeCode) {
    GWOtherSyncTypeCode			= 0,
    
    // common types
    GWHomeSyncTypeCode			= 1,
    GWWorkSyncTypeCode			= 2,
    
    // phone specific types
    GWMobileSyncTypeCode		= 3,
    GWHomeFaxSyncTypeCode		= 4,
    GWWorkFaxSyncTypeCode		= 5,
    GWPagerSyncTypeCode			= 6,
    GWMainSyncTypeCode			= 7,
    
    // date specific types
    GWAnniversarySyncTypeCode	= 8,
    
    // related name types
    GWMotherSyncTypeCode		= 9,
    GWFatherSyncTypeCode		= 10,
    GWParentSyncTypeCode		= 11,
    GWSisterSyncTypeCode		= 12,
    GWBrotherSyncTypeCode		= 13,
    GWChildSyncTypeCode			= 14,
    GWFriendSyncTypeCode		= 15,
    GWSpouseSyncTypeCode		= 16,
    GWPartnerSyncTypeCode		= 17,
    GWAssistantSyncTypeCode		= 18,
    GWManagerSyncTypeCode		= 19,
    
    // url specific
    GWHomePageSyncTypeCode		= 20
    
};

typedef enum {
    GWAIMSyncProviderCode		= 0,
    GWJabberSyncProviderCode	= 1,
    GWMSNSyncProviderCode		= 2,
    GWYahooSyncProviderCode		= 3,
    GWICQSyncProviderCode		= 4,
    GWTwitterSyncProviderCode   = 5,
    GWFacebookSyncProviderCode  = 6,
    GWLinkedInSyncProviderCode  = 7,
    GWSkypeSyncProviderCode     = 8,
    GWGaduGaduSyncProviderCode = 9,
    GWGoogleTalkSyncProviderCode = 10,
    GWQQSyncProviderCode = 11,
    GWFlickrSyncProviderCode = 12,
    GWMyspaceSyncProviderCode = 13,
    GWSinaWeiboSyncProviderCode = 14,
    GWTencentWeiboSyncProviderCode = 15
} GWSyncProviderCode;

typedef enum {
    GWPhoneTypeCode		= 0,
    GWAddressTypeCode	= 1,
    GWEmailTypeCode		= 2,
    GWURLTypeCode		= 3,
    GWIMTypeCode		= 4
} GWLabelTypeCode;

typedef enum {
    GWDeletionHandlerCannotDeleteObjectLocked     = 0,       // the object is locked by another user
    GWDeletionHandlerCannotDeleteNoWriteAccess    = 1,       // current user does not have write access for the object
    GWDeletionHandlerCannotDeleteUserCannotDelete = 2,       // current user does not have permission to delete objects in the database
    GWDeletionHandlerCannotDeleteContactIsUser    = 3,       // contact being deleted is a user in the system and therefore cannot be deleted unless unlinked from the User in the prefs
} GWDeletionHandlerCannotDeleteReason;

typedef enum {
    kGWStandardDatabaseType = kMCPStandardDatabaseType,
    kGWSampleDatabaseType = kMCPSampleDatabaseType,
    kGWOfflineDatabaseType = kMCPOfflineDatabaseType,
    kGWMirrorDatabaseType = kMCPMirrorDatabaseType
} GWDatabaseType;

typedef enum {
    kGWOfflineStatusUndefined = -1,
    kGWOfflineStatusNormal = 0,
    kGWOfflineStatusWrongEnvironment = 1,
    kGWOfflineStatusInTrial = 2,
    kGWOfflineStatusWiped = 3
} GWOfflineStatus;

/*!
 The legacy forms (used in DL3) are the standard kind. In 4, we can do webforms.
 */
typedef NS_ENUM(NSInteger, GWCustomRecordSetDefinitionKind) {
    kGWCustomRecordSetDefStandardKind = 0,
    kGWCustomRecordSetDefWebKind = 10
};

/*!
 What kind of contact information do we want to grab
 */
typedef NS_ENUM(NSInteger, GWWebFormContactBehavior) {
    kGWWebFormContactBehaviorNone = 0,
    kGWWebFormContactBehaviorNameEmailPhone = 10,
    kGWWebFormContactBehaviorFullInfoAndCompany = 20
};

/*!
 When the web form is created, how do we want to track it
 */
typedef NS_ENUM(NSInteger, GWWebFormTrackingBehavior) {
    kGWWebFormTrackingBehaviorNone = 0,
    kGWWebFormTrackingBehaviorCreateOpportunity = 10,
    kGWWebFormTrackingBehaviorCreateProject = 20,
    kGWWebFormTrackingBehaviorCustom = 30
};

typedef NS_ENUM(NSInteger, GWWebFormCompletionBehavior) {
    kGWWebFormCompletionBehaviorNone = 0,
    kGWWebFormCompletionBehaviorShowMessage = 10,
    kGWWebFormCompletionBehaviorRedirect = 20
};

typedef enum {
    GWActionItemActionTypeTask = 0,
    GWActionItemActionTypeTimeblock = 1,
} GWActionItemActionType;

typedef enum {
    GWActionItemActionFlowForward = 0,
    GWActionItemActionFlowReverse = 1,
    GWActionItemActionFlowNoDueDate = 10 // for tasks
} GWActionItemFlowType;

// FIXME: Remove this once messageForClientStatus: has been moved to MCPersisttence
#if ! TARGET_OS_IPHONE
#import "MCPMirrorSyncDefines.h"
#endif

// These defines are used by the image compression that gets done when the contact or organization's image gets set. We need to use these on both touch and desktop so i've defined them here even though the compression logic will be happening in the respective UI frameworks.
#define kDLSubstrateContactImageTargetDimension 512
#define kDLSubstrateContactImageTargetBytes 50000


// This was moved from DLAdminDefines because these values need to be shared with DLT.
#pragma mark -
#pragma mark Port Offsets
#define kDLTouchdPortOffset      2
#define kDLAttachmentdPortOffset 3
#define kDLHTTPdPortOffset       4
#define kDLDAVdPortOffset        5
#define kDLCalPublishdPortOffset 6
#define kDLFileDAVdPortOffset    7
#define kDLDAVdNoSSLPortOffset   8
#define kDLConfigKickPortOffset  10
#define kDLConfigDOPortOffset    11

// We don't have offline configuration on touch, so we have to pass the access port somehow, so we use the user defaults
extern NSString *kDLAccessdPortKey;

// In the event we can't figure out the accessd port, we use the hardcoded one. This is defined in DLAdminDefines, but we need it for touch, so we redefine it here (slightly different name)
#define kDLDefaultAccessdPort   6180



@interface GWSubstrateDefines : NSObject
{
}

#if ! TARGET_OS_IPHONE
// Move this to MCPersistence mirror sync support
+ (NSString *)messageForClientStatus:(MCPDatabaseReplicantStatus)status;
#endif

+ (NSString *)modelPath;
+ (NSString*)touchModelPath;


@end

@class MCPModel;
@interface GWSubstrate:NSObject

// Hack because we cannot programatically create a localized currency formatter -- so we have it set here from a higher thing like NSApp -- aj Jul 13/02
#if !TARGET_OS_IPHONE
+ (void)setCurrencyFormatter:(NSNumberFormatter *)formatter;
+ (NSNumberFormatter *)currencyFormatter;
+ (NSString *)localizedMoneyValue:(NSNumber *)aNumber;
#endif


@end


