//
//  GWTimeblock+VRecognition.h
//  DLSubstrate
//
//  Created by Patrick Rogers on 11-09-21.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "GWTimeblock.h"

typedef enum {
    GWTimeblockVCalOptionsRSVP          = 1UL<<0,
    GWTimeblockVCalOptionsDAVID         = 1UL<<1,
    GWTimeblockVCalOptionsICSSequence   = 1UL<<2,
    GWTimeblockVCalOptionsDatestamp     = 1UL<<3,
    GWTimeblockVCalOptionsICSOrganizer  = 1UL<<4,
    GWTimeblockVCalOptionsAttendees     = 1UL<<5,
    GWTimeblockVCalOptionsOptionalProperties = 1UL<<6,
    GWTimeblockVCalOptionsIncludeRepeats  = 1UL<<7,
    GWTimeblockVCalOptionsAlarms          = 1UL<<8,
    GWTimeblockVCalOptionsIncludeTimeZone = 1UL<<9,        // If not set times will be in GMT
    GWTimeblockVCalOptionsIncludeDescription = 1UL<<10,
#if !TARGET_OS_IPHONE
    GWTimeblockVCalOptionsIncludeAppleTravelTime = 1UL<<11,
    GWTimeblockVCalOptionsIncludeAppleStructuredLocation = 1UL<<12
#endif
} GWTimeblockVCalOptions;

@class MCiCalComponent;

typedef void (^GWTimeblockSynchronizePostProcessBlock)(GWTimeblock *timeblock,BOOL didCreate);
typedef BOOL (^GWTimeblockSynchronizeGuardBlock)(GWTimeblock *timeblock);

@interface GWTimeblock (VRecognition)
+ (void)synchronizeEventsInCalendarString:(NSString *)calendarDescription postProcessBlock:(GWTimeblockSynchronizePostProcessBlock)postProcess preProcessTest:(GWTimeblockSynchronizeGuardBlock)preProcessTest objectContext:(DLPObjectContext *)objectContext;
+ (void)synchronizeEventsInCalendar:(MCiCalComponent *)calendar postProcessBlock:(GWTimeblockSynchronizePostProcessBlock)postProcess preProcessTest:(GWTimeblockSynchronizeGuardBlock)preProcessTest objectContext:(DLPObjectContext *)objectContext;
+ (GWTimeblock *)timeblockWithCalendarVEvent:(NSString *)eventDescription objectContext:(DLPObjectContext *)objectContext;

+ (NSMutableArray *)timeblocksWithVCalendar:(NSString *)eventDescription objectContext:(DLPObjectContext *)objectContext hasTasks:(BOOL *)aBool delegate:(id)delegate;

// returns the object that was updated
- (GWTimeblock*)updateWithEventString:(NSString *)eventString createMissingContacts:(BOOL)createMissingContacts;
- (GWTimeblock*)updateWithEvent:(MCiCalComponent *)mcEvent createMissingContacts:(BOOL)createMissingContacts;
- (GWTimeblock*)updateWithEvent:(MCiCalComponent *)mcEvent createMissingContacts:(BOOL)createMissingContacts clearCategory:(BOOL)clearCategory;
- (GWTimeblock*)updateWithEvent:(MCiCalComponent *)mcEvent createMissingContacts:(BOOL)createMissingContacts clearCategory:(BOOL)clearCategory ignoreExternalOrganizationAndAttendees:(BOOL)ignoreExternal;

- (MCiCalComponent *)vCalendarRepresentation:(NSUInteger)options;
- (MCiCalComponent *)vCalendarRepresentation;
@end

@interface NSArray (VRecognition)
- (MCiCalComponent *)vCalendarRepresentation;
- (MCiCalComponent *)vCalendarRepresentation:(NSUInteger)options;
@end
