//
//  MCDocument.h
//  MCAppKit
//
//  Created by Ali Lalani on 09-09-29.
//  Copyright 2009 Marketcircle, Inc. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#import "MiscMergeEngine.h"
#import "MiscMergeTemplate.h"

extern NSString *kMCDocumentDidCloseNotification;

@interface MCDocument : NSDocument {

}

#pragma mark -
#pragma mark Window Controller Conveniences
// Looks for existing window controllers for the given class, returns the first one found or nil if not found
- (id)firstWindowControllerOfClass:(Class)aClass;
// Looks for existing window controllers for the given class, returns the first one found, nil if not found or a new one if flag is YES
- (id)firstWindowControllerOfClass:(Class)aClass
				  createIfNotFound:(BOOL)flag 
						showWindow:(BOOL)show;
- (id)makeWindowControllerOfClass:(Class)aClass;

// Finds the first window controller (in order of when they were last made key)
- (id)mcFirstOrderedWindowControllerOfClass:(Class)aClass
                         createIfNotFound:(BOOL)flag 
                               showWindow:(BOOL)show;
- (id)mcFirstOrderedWindowControllerOfClass:(Class)aClass;

#pragma mark RepresentedMenuCommandSupport
- (BOOL)validatedRepresentedCommandInMenuItem:(NSMenuItem *)menuItem;

@end

@interface MiscMergeEngine (MCDocment)
+ (NSFileWrapper *)mergeWithObject:(id)anObject sender:sender RTFFileWrapper:(NSFileWrapper *)wrapper encoding:(NSStringEncoding)encoding;
- (void)replaceObjectAddressIdentifiersWithObjectsInString:(NSMutableAttributedString *)attr;
@end