//
//  MCPMirrorSyncDefines.h
//  MCPersistence
//
//  Created by Michael Clark on 12-01-03.
//  Copyright (c) 2012 Marketcircle Inc. All rights reserved.
//

extern NSString* kMCPMirrorSyncErrorDomain;

typedef NS_ENUM(NSInteger, MCPMirrorSyncErrorCode) {
    kMCPMirrorSyncMasterConnectionError = 10
};


// OfflineConfiguration Status
typedef NS_ENUM(NSInteger, MCPOfflineConfigurationStatus) {
    kMCPOfflineConfigurationStatusUndefined = -1,
    kMCPOfflineConfigurationStatusNormal = 0,
    kMCPOfflineConfigurationStatusWrongEnvironment = 1,
    kMCPOfflineConfigurationStatusInTrial = 2,
    kMCPOfflineConfigurationStatusWiped = 3
};


// DatabaseReplicant Types
typedef NS_ENUM(NSInteger, MCPDatabaseReplicantType) {
    kMCPDatabaseReplicantTypeUndefined = 0,
    kMCPDatabaseReplicantTypeOffline = 1,
    kMCPDatabaseReplicantTypeTouch = 2,
    kMCPDatabaseReplicantTypeMirror = 3
};

// DatabaseReplicant Status
typedef NS_ENUM(NSInteger, MCPDatabaseReplicantStatus) {
    kMCPDatabaseReplicantStatusUndefined = -1,
    kMCPDatabaseReplicantStatusActive = 0,
    kMCPDatabaseReplicantStatusInactive = 1, // Deprecated - no longer use, replaced by Retired
    kMCPDatabaseReplicantStatusRetired = 1,
    kMCPDatabaseReplicantStatusSyncFailed = 2,
    kMCPDatabaseReplicantStatusSyncOverdue = 3,
    kMCPDatabaseReplicantStatusWaitingToWipe = 4,
    kMCPDatabaseReplicantStatusInitInProgress = 5,
    kMCPDatabaseReplicantStatusOnline = 6,
    kMCPDatabaseReplicantStatusRevoked = 7
};



@class MCPMirrorSyncDefines;
@interface MCPMirrorSyncDefines : NSObject

+ (MCPMirrorSyncDefines*)objectForLocalization;

+ (NSString*)replicantStatusMessageForStatusCode: (MCPDatabaseReplicantStatus)status;
+ (NSString*)replicantTypeMessageForTypeCode: (MCPDatabaseReplicantType)type;

@end
