//
//  MCWindowController.h
//  MCAppKit
//
//  Created by Ali Lalani on 09-09-16.
//  Copyright 2009 Marketcircle, Inc. All rights reserved.
//
/*
 
 This class should contain any *common* and *generic* concepts and conveniences for use by any application.
 
*/

#import <Cocoa/Cocoa.h>


@interface MCWindowController : NSWindowController 

@property (nonatomic,weak) IBOutlet NSProgressIndicator *progressIndicator;
@property (nonatomic,weak) IBOutlet NSTextField *progressField;
/*!
 Subclassers can override the name of the nib to be loaded. Default is [self className].
 */
- (NSString *)nibName;

/*!
 Convenience to run a sheet. Subclasses can override windowControllerSheetDidEnd... if needed.
 */
- (void)runSheetInWindow:(NSWindow *)aWindow;
- (void)windowControllerSheetDidEnd:(NSWindow *)sheet 
						 returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo;



// Progress indicator functionality
- (void)setupProgressIndicatorForDisplayWithTotalIncrements:(int)incr initialMessage:(NSString *)message;
// This method does the same as above, except if flag is NO it will not increment by 1 the progress indicator
// like the above will if the message is not nil!!!!!!!
- (void)setupProgressIndicatorForDisplayWithTotalIncrements: (int)incr initialMessage: (NSString *)message
                                                  increment: (BOOL)flag;
- (void)incrementIndicatorWithMessage:(NSString *)message;
- (void)setMessage: (NSString *)message;
- (void)incrementIndicator;
- (void)setIndicatorTotalIncrements: (int)increments;
- (void)addToIncrements: (int)more_increments;
- (void)hideProgressIndicator;
- (NSProgressIndicator *)progressIndicator;
- (void)startIndeterminateProgressWithMessage:(NSString *)aMessage;



@end
