//
//  MCiCalComponent.h
//  MCLibicalWrapper1
//
//  Created by Eric Hochmeister on 10/01/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ical.h"

@class MCiCalProperty,MCiCalEvent;

@interface MCiCalComponent : NSObject {
    icalcomponent* calComponentPtr;
    BOOL freeOnDealloc;
}

+ (MCiCalComponent*)parseString:(NSString*)aString;
+ (MCiCalComponent*)iCalComponentWithString:(NSString *)calendarDescription;
+ (MCiCalComponent*)iCalComponentWithData:(NSData *)someUTF8Data;
+ (MCiCalEvent *)iCalEventWithData:(NSData *)someUTF8Data; // DO NOT USE: Deprecated
+ (MCiCalComponent*)iCalComponentWithCalComponentPtr:(icalcomponent*)tmpComp;
+ (MCiCalComponent*)iCalComponentWithCalComponentPtrUnsafe:(icalcomponent*)tmpComp;

- (id)initWithCalComponentPtr:(icalcomponent*)aComp;
- (id)initWithCalComponentPtrUnsafe:(icalcomponent*)aComp;

// accessors

- (NSString *)getXPropertyValue:(NSString *)propertyName;
- (icalcomponent*)calComponentPtr;
- (icalcomponent*)extractComponentPtrAndAssumeOwnership;
- (MCiCalComponent*)inner;  // The inner component will become invalid when this is dealloced

- (NSString*)iCalString;

- (void)setSequence:(NSInteger)sequence;
- (NSInteger)sequence;

- (icalcomponent_kind)kind;

- (NSInteger)numOfProperties;
- (MCiCalProperty*)firstPropertyWithKind:(icalproperty_kind)kind;
- (BOOL)isValid;

- (NSEnumerator*)componentEnumerator;
- (NSEnumerator*)componentEnumeratorForKind:(icalcomponent_kind)aKind;

- (NSEnumerator*)propertyEnumerator;
- (NSEnumerator*)propertyEnumeratorForKind:(icalproperty_kind)aKind;
- (NSArray*)propertiesOfType:(icalproperty_kind)kind;

- (NSArray *)propertiesInGroup:(NSUInteger)group;

- (void)removePropertiesInGroup:(NSUInteger)group;
- (void)removePropertiesOfType:(icalproperty_kind)kind includeGroupItems:(BOOL)includeGroupItems;

- (NSString*)description;

@end
