//
//  NSColor+MCAdditions.h
//  MCAppKit
//
//  Created by Fraser Kuyvenhoven on 10-03-25.
//  Copyright 2010 Marketcircle Inc. All rights reserved.
//

#import <Cocoa/Cocoa.h>

const extern CGFloat MCLightBackgroundLuminosity;

@interface NSColor (MCAdditions)
@property (nonatomic,readonly) CGColorRef CGColor;
@property (nonatomic,readonly) NSDictionary *mcDictionaryRepresentation;
@property (nonatomic,readonly) NSString *mcHexStringRepresentation;
@property (nonatomic,readonly) NSColor *mcContrastingLabelColor;
@property (nonatomic,readonly) NSShadow *mcContrastingShadow;
@property (nonatomic,readonly) CGFloat mcAverageGray;
@property (nonatomic,readonly) BOOL mcIsLightColor;

+ (NSColor *)mcColorFromDictionaryRepresentation:(NSDictionary *)aDictionary;

+ (NSColor *)mcColorFromHexString:(NSString *)inColorString;

- (BOOL)mcIsLightColorWithBackgroundColor:(NSColor *)background;
- (NSColor *)mcContrastingLabelColorWithBackgroundColor:(NSColor *)background;
- (CGFloat)mcAverageGrayWithBackgroundColor:(NSColor *)background;
- (NSShadow *)mcContrastingShadowWithBackgroundColor:(NSColor *)background;
- (NSColor *)mcColourWithAverageGray:(CGFloat)desiredGray saturateOverflow:(BOOL)saturateOverflow;

- (NSColor *)mcNormalizeLuminosity:(CGFloat)adjustmentFactor;
- (NSColor *)mcAdjustLuminosity:(CGFloat)luminosityFactor;
- (NSColor *)mcMixWithColor:(NSColor *)otherColor mixingPoint:(CGFloat)mixingPoint;

- (NSColor *)mcAdjustedBackgroundColor;
- (NSColor *)mcAdjustedSelectedColor;
- (NSColor *)mcAdjustedBarColor;
- (NSColor *)mcAdjustedTextColor;
- (NSColor *)mcAdjustedTextColorOnWhite;

@end
