//
//  NSImage+MCAdditions.h
//  MCAppKit
//
//  Created by Ali Lalani on 10-01-21.
//  Copyright 2010 Marketcircle, Inc. All rights reserved.
//

#import <Cocoa/Cocoa.h>

NSData *CloserInSizeToBytes(NSUInteger targetBytes,NSData *data1, NSData *data2);

@interface NSImage (MCAdditions)
#pragma mark -
#pragma mark Image Loading Conveniences
+ (NSImage *)mcImageNamed:(NSString *)imageName inBundle:(NSBundle *)aBundle;
+ (NSImage *)mcImageNamed:(NSString *)imageName inBundleWithIdentifier:(NSString *)anIdentifier;
+ (NSImage *)mcImageNamed:(NSString *)imageName inBundleForClass:(Class)aClass;

#pragma mark -
#pragma mark Drawing Conveniences
- (void)mcDrawInRect:(NSRect)aRect;
- (void)mcDrawAtPoint:(NSPoint)aPoint;

#pragma mark -
#pragma mark Transforms
- (NSImage *)mcImageByRotatingByDegrees:(CGFloat)degrees;

#pragma mark -
#pragma mark Modifications
- (NSImage *)mcImageWithAlpha:(CGFloat)alpha;
- (NSImage *)mcImageWithTint:(NSColor *)tintColour foreground:(NSImage *)foregroundImage;
- (NSImage *)mcImageWithTint:(NSColor *)tintColour shadow:(NSShadow *)shadow;

#pragma mark -
#pragma mark Compression
- (NSData *)mcJPEGImageDataWithTargetDimension:(NSUInteger)dimension maxBytes:(NSUInteger)maxBytes;

@end
