
// _GWKeyword.h
// GWSubstrate
// 
// Created by eogenerator
// DO NOT EDIT.  Make changes to GWKeyword.h instead.
// 
// Copyright (c) 2001 Marketcircle Inc. All rights reserved.

#import "MCPObject.h"

#import "DLPObject.h"


@class GWEmail;
@class GWActionItem;
@class GWGroup;
@class GWContact;
@class GWCustomRecordSet;
@class GWTask;
@class GWOpportunity;
@class GWTimeblock;
@class GWOrganization;
@class GWProject;
@class GWNote;

@interface _GWKeyword : DLPObject
{ 
}

+ (NSString*)entityName;

#pragma mark -
#pragma mark Attributes

@property(nonatomic,readwrite,strong)NSNumber *forEmail;
@property(nonatomic,readwrite,strong)NSNumber *forGroup;
@property(nonatomic,readwrite,strong)NSNumber *forCustomRecordSet;
@property(nonatomic,readwrite,strong)NSNumber *forNote;
@property(nonatomic,readwrite,strong)NSNumber *forTimeblock;
@property(nonatomic,readwrite,strong)NSNumber *forTask;
@property(nonatomic,readwrite,strong)NSNumber *rootID;
@property(nonatomic,readwrite,strong)NSNumber *order;
@property(nonatomic,readwrite,strong)NSString *name;
@property(nonatomic,readwrite,strong)NSNumber *keywordID;
@property(nonatomic,readwrite,strong)NSNumber *forProject;
@property(nonatomic,readwrite,strong)NSNumber *forOrganization;
@property(nonatomic,readwrite,strong)NSNumber *forOpportunity;
@property(nonatomic,readwrite,strong)NSNumber *forContact;
@property(nonatomic,readwrite,strong)NSDate *createDate;
@property(nonatomic,readwrite,strong)NSNumber *active;



#pragma mark -
#pragma mark To-One Relationships




#pragma mark -
#pragma mark To-Many Relationships

@property(nonatomic,readonly) NSArray* actionItems;
@property(nonatomic,readonly) BOOL hasActionItemsBeenFaulted;
- (GWActionItem*)createAndAddToActionItems;
- (void)faultActionItemsAndNotify: (void (^)())block;
- (void)addToActionItems:(GWActionItem*)object;
- (void)removeFromActionItems:(GWActionItem*)object;


@property(nonatomic,readonly) NSArray* keywordActionItems;
@property(nonatomic,readonly) BOOL hasKeywordActionItemsBeenFaulted;
- (MCPObject*)createAndAddToKeywordActionItems;
- (void)faultKeywordActionItemsAndNotify: (void (^)())block;
- (void)addToKeywordActionItems:(MCPObject*)object;
- (void)removeFromKeywordActionItems:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* emails;
@property(nonatomic,readonly) BOOL hasEmailsBeenFaulted;
- (GWEmail*)createAndAddToEmails;
- (void)faultEmailsAndNotify: (void (^)())block;
- (void)addToEmails:(GWEmail*)object;
- (void)removeFromEmails:(GWEmail*)object;


@property(nonatomic,readonly) NSArray* keywordEmails;
@property(nonatomic,readonly) BOOL hasKeywordEmailsBeenFaulted;
- (MCPObject*)createAndAddToKeywordEmails;
- (void)faultKeywordEmailsAndNotify: (void (^)())block;
- (void)addToKeywordEmails:(MCPObject*)object;
- (void)removeFromKeywordEmails:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* groups;
@property(nonatomic,readonly) BOOL hasGroupsBeenFaulted;
- (GWGroup*)createAndAddToGroups;
- (void)faultGroupsAndNotify: (void (^)())block;
- (void)addToGroups:(GWGroup*)object;
- (void)removeFromGroups:(GWGroup*)object;


@property(nonatomic,readonly) NSArray* keywordGroups;
@property(nonatomic,readonly) BOOL hasKeywordGroupsBeenFaulted;
- (MCPObject*)createAndAddToKeywordGroups;
- (void)faultKeywordGroupsAndNotify: (void (^)())block;
- (void)addToKeywordGroups:(MCPObject*)object;
- (void)removeFromKeywordGroups:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* customRecordSets;
@property(nonatomic,readonly) BOOL hasCustomRecordSetsBeenFaulted;
- (GWCustomRecordSet*)createAndAddToCustomRecordSets;
- (void)faultCustomRecordSetsAndNotify: (void (^)())block;
- (void)addToCustomRecordSets:(GWCustomRecordSet*)object;
- (void)removeFromCustomRecordSets:(GWCustomRecordSet*)object;


@property(nonatomic,readonly) NSArray* keywordCustomRecordSets;
@property(nonatomic,readonly) BOOL hasKeywordCustomRecordSetsBeenFaulted;
- (MCPObject*)createAndAddToKeywordCustomRecordSets;
- (void)faultKeywordCustomRecordSetsAndNotify: (void (^)())block;
- (void)addToKeywordCustomRecordSets:(MCPObject*)object;
- (void)removeFromKeywordCustomRecordSets:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* tasks;
@property(nonatomic,readonly) BOOL hasTasksBeenFaulted;
- (GWTask*)createAndAddToTasks;
- (void)faultTasksAndNotify: (void (^)())block;
- (void)addToTasks:(GWTask*)object;
- (void)removeFromTasks:(GWTask*)object;


@property(nonatomic,readonly) NSArray* timeblocks;
@property(nonatomic,readonly) BOOL hasTimeblocksBeenFaulted;
- (GWTimeblock*)createAndAddToTimeblocks;
- (void)faultTimeblocksAndNotify: (void (^)())block;
- (void)addToTimeblocks:(GWTimeblock*)object;
- (void)removeFromTimeblocks:(GWTimeblock*)object;


@property(nonatomic,readonly) NSArray* notes;
@property(nonatomic,readonly) BOOL hasNotesBeenFaulted;
- (GWNote*)createAndAddToNotes;
- (void)faultNotesAndNotify: (void (^)())block;
- (void)addToNotes:(GWNote*)object;
- (void)removeFromNotes:(GWNote*)object;


@property(nonatomic,readonly) NSArray* keywordTimeblocks;
@property(nonatomic,readonly) BOOL hasKeywordTimeblocksBeenFaulted;
- (MCPObject*)createAndAddToKeywordTimeblocks;
- (void)faultKeywordTimeblocksAndNotify: (void (^)())block;
- (void)addToKeywordTimeblocks:(MCPObject*)object;
- (void)removeFromKeywordTimeblocks:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* keywordTasks;
@property(nonatomic,readonly) BOOL hasKeywordTasksBeenFaulted;
- (MCPObject*)createAndAddToKeywordTasks;
- (void)faultKeywordTasksAndNotify: (void (^)())block;
- (void)addToKeywordTasks:(MCPObject*)object;
- (void)removeFromKeywordTasks:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* keywordNotes;
@property(nonatomic,readonly) BOOL hasKeywordNotesBeenFaulted;
- (MCPObject*)createAndAddToKeywordNotes;
- (void)faultKeywordNotesAndNotify: (void (^)())block;
- (void)addToKeywordNotes:(MCPObject*)object;
- (void)removeFromKeywordNotes:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* projects;
@property(nonatomic,readonly) BOOL hasProjectsBeenFaulted;
- (GWProject*)createAndAddToProjects;
- (void)faultProjectsAndNotify: (void (^)())block;
- (void)addToProjects:(GWProject*)object;
- (void)removeFromProjects:(GWProject*)object;


@property(nonatomic,readonly) NSArray* organizations;
@property(nonatomic,readonly) BOOL hasOrganizationsBeenFaulted;
- (GWOrganization*)createAndAddToOrganizations;
- (void)faultOrganizationsAndNotify: (void (^)())block;
- (void)addToOrganizations:(GWOrganization*)object;
- (void)removeFromOrganizations:(GWOrganization*)object;


@property(nonatomic,readonly) NSArray* opportunities;
@property(nonatomic,readonly) BOOL hasOpportunitiesBeenFaulted;
- (GWOpportunity*)createAndAddToOpportunities;
- (void)faultOpportunitiesAndNotify: (void (^)())block;
- (void)addToOpportunities:(GWOpportunity*)object;
- (void)removeFromOpportunities:(GWOpportunity*)object;


@property(nonatomic,readonly) NSArray* keywordProjects;
@property(nonatomic,readonly) BOOL hasKeywordProjectsBeenFaulted;
- (MCPObject*)createAndAddToKeywordProjects;
- (void)faultKeywordProjectsAndNotify: (void (^)())block;
- (void)addToKeywordProjects:(MCPObject*)object;
- (void)removeFromKeywordProjects:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* keywordOrganizations;
@property(nonatomic,readonly) BOOL hasKeywordOrganizationsBeenFaulted;
- (MCPObject*)createAndAddToKeywordOrganizations;
- (void)faultKeywordOrganizationsAndNotify: (void (^)())block;
- (void)addToKeywordOrganizations:(MCPObject*)object;
- (void)removeFromKeywordOrganizations:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* keywordOpportunitys;
@property(nonatomic,readonly) BOOL hasKeywordOpportunitysBeenFaulted;
- (MCPObject*)createAndAddToKeywordOpportunitys;
- (void)faultKeywordOpportunitysAndNotify: (void (^)())block;
- (void)addToKeywordOpportunitys:(MCPObject*)object;
- (void)removeFromKeywordOpportunitys:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* contacts;
@property(nonatomic,readonly) BOOL hasContactsBeenFaulted;
- (GWContact*)createAndAddToContacts;
- (void)faultContactsAndNotify: (void (^)())block;
- (void)addToContacts:(GWContact*)object;
- (void)removeFromContacts:(GWContact*)object;


@property(nonatomic,readonly) NSArray* contactKeywords;
@property(nonatomic,readonly) BOOL hasContactKeywordsBeenFaulted;
- (MCPObject*)createAndAddToContactKeywords;
- (void)faultContactKeywordsAndNotify: (void (^)())block;
- (void)addToContactKeywords:(MCPObject*)object;
- (void)removeFromContactKeywords:(MCPObject*)object;




//- (id)initWithCoder:(NSCoder *)decoder;
//- (void)encodeWithCoder:(NSCoder *)coder;

@end
