
// _GWPipelineStage.h
// GWSubstrate
// 
// Created by eogenerator
// DO NOT EDIT.  Make changes to GWPipelineStage.h instead.
// 
// Copyright (c) 2001 Marketcircle Inc. All rights reserved.

#import "MCPObject.h"

#import "DLPObject.h"


@class GWTimeblock;
@class GWOpportunity;
@class GWTask;
@class GWPipelineStageDefinition;
@class GWPipeline;
@class GWProject;

@interface _GWPipelineStage : DLPObject
{ 
}

+ (NSString*)entityName;

#pragma mark -
#pragma mark Attributes

@property(nonatomic,readwrite,strong)NSNumber *opportunityID;
@property(nonatomic,readwrite,strong)NSNumber *projectID;
@property(nonatomic,readwrite,strong)NSNumber *isActivitySetCreated;
@property(nonatomic,readwrite,strong)NSNumber *pipelineStageDefinitionID;
@property(nonatomic,readwrite,strong)NSNumber *upperThreshold;
@property(nonatomic,readwrite,strong)NSNumber *pipelineStageID;
@property(nonatomic,readwrite,strong)NSNumber *pipelineID;
@property(nonatomic,readwrite,strong)NSNumber *order;
@property(nonatomic,readwrite,strong)NSString *note;
@property(nonatomic,readwrite,strong)NSString *name;
@property(nonatomic,readwrite,strong)NSDate *modifyDate;
@property(nonatomic,readwrite,strong)NSNumber *lowerThreshold;
@property(nonatomic,readwrite,strong)NSDate *createDate;



#pragma mark -
#pragma mark To-One Relationships

@property(nonatomic,readwrite,strong)GWPipelineStageDefinition* pipelineStageDefinition;
- (GWPipelineStageDefinition*)createAndSetPipelineStageDefinitionIfNeeded;
- (void)faultPipelineStageDefinitionAndNotify: (void (^)())block;


@property(nonatomic,readwrite,strong)GWPipeline* pipeline;
- (GWPipeline*)createAndSetPipelineIfNeeded;
- (void)faultPipelineAndNotify: (void (^)())block;


@property(nonatomic,readwrite,strong)GWProject* project;
- (GWProject*)createAndSetProjectIfNeeded;
- (void)faultProjectAndNotify: (void (^)())block;


@property(nonatomic,readwrite,strong)GWOpportunity* opportunity;
- (GWOpportunity*)createAndSetOpportunityIfNeeded;
- (void)faultOpportunityAndNotify: (void (^)())block;





#pragma mark -
#pragma mark To-Many Relationships

@property(nonatomic,readonly) NSArray* pipelineStageTimeblocks;
@property(nonatomic,readonly) BOOL hasPipelineStageTimeblocksBeenFaulted;
- (MCPObject*)createAndAddToPipelineStageTimeblocks;
- (void)faultPipelineStageTimeblocksAndNotify: (void (^)())block;
- (void)addToPipelineStageTimeblocks:(MCPObject*)object;
- (void)removeFromPipelineStageTimeblocks:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* timeblocks;
@property(nonatomic,readonly) BOOL hasTimeblocksBeenFaulted;
- (GWTimeblock*)createAndAddToTimeblocks;
- (void)faultTimeblocksAndNotify: (void (^)())block;
- (void)addToTimeblocks:(GWTimeblock*)object;
- (void)removeFromTimeblocks:(GWTimeblock*)object;


@property(nonatomic,readonly) NSArray* pipelineStageTasks;
@property(nonatomic,readonly) BOOL hasPipelineStageTasksBeenFaulted;
- (MCPObject*)createAndAddToPipelineStageTasks;
- (void)faultPipelineStageTasksAndNotify: (void (^)())block;
- (void)addToPipelineStageTasks:(MCPObject*)object;
- (void)removeFromPipelineStageTasks:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* tasks;
@property(nonatomic,readonly) BOOL hasTasksBeenFaulted;
- (GWTask*)createAndAddToTasks;
- (void)faultTasksAndNotify: (void (^)())block;
- (void)addToTasks:(GWTask*)object;
- (void)removeFromTasks:(GWTask*)object;




//- (id)initWithCoder:(NSCoder *)decoder;
//- (void)encodeWithCoder:(NSCoder *)coder;

@end
