
// _GWSourceList.h
// GWSubstrate
//
// Created by eogenerator
// DO NOT EDIT.  Make changes to GWSourceList.h instead.
//
// Copyright (c) 2001 Marketcircle Inc. All rights reserved.

#import "MCPObject.h"

#import "DLPObject.h"


@class GWCustomRecordSet;
@class GWOrganization;
@class GWSourceList;
@class GWNote;
@class GWUser;
@class GWContact;
@class GWGroup;
@class GWDisplayState;
@class GWProject;
@class GWTeam;
@class GWTask;
@class GWOpportunity;
@class GWTimeblock;
@class GWEmail;

@interface _GWSourceList : DLPObject
{
}

+ (NSString*)entityName;

#pragma mark -
#pragma mark Attributes

@property(nonatomic,readwrite,strong)NSString *publishIdentifier;
@property(nonatomic,readwrite,strong)NSNumber *isPublished;
@property(nonatomic,readwrite,strong)NSNumber *isShared;
@property(nonatomic,readwrite,strong)NSString *writePermissions;
@property(nonatomic,readwrite,strong)NSString *readPermissions;
@property(nonatomic,readwrite,strong)NSNumber *shareTeamID;
@property(nonatomic,readwrite,strong)NSData *criteriaPlistRepresentation;
@property(nonatomic,readwrite,strong)NSNumber *typeCode;
@property(nonatomic,readwrite,strong)NSNumber *sourceListID;
@property(nonatomic,readwrite,strong)NSNumber *permissionMask;
@property(nonatomic,readwrite,strong)NSNumber *parentListID;
@property(nonatomic,readwrite,strong)NSNumber *orderCode;
@property(nonatomic,readwrite,strong)NSString *name;
@property(nonatomic,readwrite,strong)NSNumber *isHiddenFlag;
@property(nonatomic,readwrite,strong)NSNumber *isDefaultCode;
@property(nonatomic,readwrite,strong)NSString *groupIdentifier;
@property(nonatomic,readwrite,strong)NSString *forEntityName;
@property(nonatomic,readwrite,strong)NSData *filterUIState;
@property(nonatomic,readwrite,strong)NSString *details;
@property(nonatomic,readwrite,strong)NSNumber *assignedToID;
@property(nonatomic,readwrite,strong)NSNumber *applicationTypeCode;



#pragma mark -
#pragma mark To-One Relationships

@property(nonatomic,readwrite,strong)GWTeam* shareTeam;
- (GWTeam*)createAndSetShareTeamIfNeeded;
- (void)faultShareTeamAndNotify: (void (^)())block;


@property(nonatomic,readwrite,strong)GWSourceList* parentList;
- (GWSourceList*)createAndSetParentListIfNeeded;
- (void)faultParentListAndNotify: (void (^)())block;


@property(nonatomic,readwrite,strong)GWUser* assignedTo;
- (GWUser*)createAndSetAssignedToIfNeeded;
- (void)faultAssignedToAndNotify: (void (^)())block;





#pragma mark -
#pragma mark To-Many Relationships

@property(nonatomic,readonly) NSArray* emails;
@property(nonatomic,readonly) BOOL hasEmailsBeenFaulted;
- (GWEmail*)createAndAddToEmails;
- (void)faultEmailsAndNotify: (void (^)())block;
- (void)insertEmail:(GWEmail*)object atIndex: (NSUInteger)index;
- (void)insertEmail:(GWEmail*)object1 beforeEmail:(GWEmail*)object2;
- (void)insertEmail:(GWEmail*)object1 afterEmail:(GWEmail*)object2;
- (void)moveEmail:(GWEmail*)object toIndex: (NSUInteger)index;
- (void)moveEmail:(GWEmail*)object1 toBeforeEmail:(GWEmail*)object2;
- (void)moveEmail:(GWEmail*)object1 toAfterEmail:(GWEmail*)object2;
- (void)swapEmail:(GWEmail*)object1 withEmail:(GWEmail*)object2;
- (void)addToEmails:(GWEmail*)object;
- (void)removeFromEmails:(GWEmail*)object;


@property(nonatomic,readonly) NSArray* dumbListEmails;
@property(nonatomic,readonly) BOOL hasDumbListEmailsBeenFaulted;
- (MCPObject*)createAndAddToDumbListEmails;
- (void)faultDumbListEmailsAndNotify: (void (^)())block;
- (void)addToDumbListEmails:(MCPObject*)object;
- (void)removeFromDumbListEmails:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* customRecordSets;
@property(nonatomic,readonly) BOOL hasCustomRecordSetsBeenFaulted;
- (GWCustomRecordSet*)createAndAddToCustomRecordSets;
- (void)faultCustomRecordSetsAndNotify: (void (^)())block;
- (void)insertCustomRecordSet:(GWCustomRecordSet*)object atIndex: (NSUInteger)index;
- (void)insertCustomRecordSet:(GWCustomRecordSet*)object1 beforeCustomRecordSet:(GWCustomRecordSet*)object2;
- (void)insertCustomRecordSet:(GWCustomRecordSet*)object1 afterCustomRecordSet:(GWCustomRecordSet*)object2;
- (void)moveCustomRecordSet:(GWCustomRecordSet*)object toIndex: (NSUInteger)index;
- (void)moveCustomRecordSet:(GWCustomRecordSet*)object1 toBeforeCustomRecordSet:(GWCustomRecordSet*)object2;
- (void)moveCustomRecordSet:(GWCustomRecordSet*)object1 toAfterCustomRecordSet:(GWCustomRecordSet*)object2;
- (void)swapCustomRecordSet:(GWCustomRecordSet*)object1 withCustomRecordSet:(GWCustomRecordSet*)object2;
- (void)addToCustomRecordSets:(GWCustomRecordSet*)object;
- (void)removeFromCustomRecordSets:(GWCustomRecordSet*)object;


@property(nonatomic,readonly) NSArray* customRecordSetDumbLists;
@property(nonatomic,readonly) BOOL hasCustomRecordSetDumbListsBeenFaulted;
- (MCPObject*)createAndAddToCustomRecordSetDumbLists;
- (void)faultCustomRecordSetDumbListsAndNotify: (void (^)())block;
- (void)addToCustomRecordSetDumbLists:(MCPObject*)object;
- (void)removeFromCustomRecordSetDumbLists:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* notes;
@property(nonatomic,readonly) BOOL hasNotesBeenFaulted;
- (GWNote*)createAndAddToNotes;
- (void)faultNotesAndNotify: (void (^)())block;
- (void)insertNote:(GWNote*)object atIndex: (NSUInteger)index;
- (void)insertNote:(GWNote*)object1 beforeNote:(GWNote*)object2;
- (void)insertNote:(GWNote*)object1 afterNote:(GWNote*)object2;
- (void)moveNote:(GWNote*)object toIndex: (NSUInteger)index;
- (void)moveNote:(GWNote*)object1 toBeforeNote:(GWNote*)object2;
- (void)moveNote:(GWNote*)object1 toAfterNote:(GWNote*)object2;
- (void)swapNote:(GWNote*)object1 withNote:(GWNote*)object2;
- (void)addToNotes:(GWNote*)object;
- (void)removeFromNotes:(GWNote*)object;


@property(nonatomic,readonly) NSArray* noteDumbLists;
@property(nonatomic,readonly) BOOL hasNoteDumbListsBeenFaulted;
- (MCPObject*)createAndAddToNoteDumbLists;
- (void)faultNoteDumbListsAndNotify: (void (^)())block;
- (void)addToNoteDumbLists:(MCPObject*)object;
- (void)removeFromNoteDumbLists:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* timeblocks;
@property(nonatomic,readonly) BOOL hasTimeblocksBeenFaulted;
- (GWTimeblock*)createAndAddToTimeblocks;
- (void)faultTimeblocksAndNotify: (void (^)())block;
- (void)insertTimeblock:(GWTimeblock*)object atIndex: (NSUInteger)index;
- (void)insertTimeblock:(GWTimeblock*)object1 beforeTimeblock:(GWTimeblock*)object2;
- (void)insertTimeblock:(GWTimeblock*)object1 afterTimeblock:(GWTimeblock*)object2;
- (void)moveTimeblock:(GWTimeblock*)object toIndex: (NSUInteger)index;
- (void)moveTimeblock:(GWTimeblock*)object1 toBeforeTimeblock:(GWTimeblock*)object2;
- (void)moveTimeblock:(GWTimeblock*)object1 toAfterTimeblock:(GWTimeblock*)object2;
- (void)swapTimeblock:(GWTimeblock*)object1 withTimeblock:(GWTimeblock*)object2;
- (void)addToTimeblocks:(GWTimeblock*)object;
- (void)removeFromTimeblocks:(GWTimeblock*)object;


@property(nonatomic,readonly) NSArray* timeblockDumbLists;
@property(nonatomic,readonly) BOOL hasTimeblockDumbListsBeenFaulted;
- (MCPObject*)createAndAddToTimeblockDumbLists;
- (void)faultTimeblockDumbListsAndNotify: (void (^)())block;
- (void)addToTimeblockDumbLists:(MCPObject*)object;
- (void)removeFromTimeblockDumbLists:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* tasks;
@property(nonatomic,readonly) BOOL hasTasksBeenFaulted;
- (GWTask*)createAndAddToTasks;
- (void)faultTasksAndNotify: (void (^)())block;
- (void)insertTask:(GWTask*)object atIndex: (NSUInteger)index;
- (void)insertTask:(GWTask*)object1 beforeTask:(GWTask*)object2;
- (void)insertTask:(GWTask*)object1 afterTask:(GWTask*)object2;
- (void)moveTask:(GWTask*)object toIndex: (NSUInteger)index;
- (void)moveTask:(GWTask*)object1 toBeforeTask:(GWTask*)object2;
- (void)moveTask:(GWTask*)object1 toAfterTask:(GWTask*)object2;
- (void)swapTask:(GWTask*)object1 withTask:(GWTask*)object2;
- (void)addToTasks:(GWTask*)object;
- (void)removeFromTasks:(GWTask*)object;


@property(nonatomic,readonly) NSArray* taskDumbLists;
@property(nonatomic,readonly) BOOL hasTaskDumbListsBeenFaulted;
- (MCPObject*)createAndAddToTaskDumbLists;
- (void)faultTaskDumbListsAndNotify: (void (^)())block;
- (void)addToTaskDumbLists:(MCPObject*)object;
- (void)removeFromTaskDumbLists:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* opportunities;
@property(nonatomic,readonly) BOOL hasOpportunitiesBeenFaulted;
- (GWOpportunity*)createAndAddToOpportunities;
- (void)faultOpportunitiesAndNotify: (void (^)())block;
- (void)insertOpportunity:(GWOpportunity*)object atIndex: (NSUInteger)index;
- (void)insertOpportunity:(GWOpportunity*)object1 beforeOpportunity:(GWOpportunity*)object2;
- (void)insertOpportunity:(GWOpportunity*)object1 afterOpportunity:(GWOpportunity*)object2;
- (void)moveOpportunity:(GWOpportunity*)object toIndex: (NSUInteger)index;
- (void)moveOpportunity:(GWOpportunity*)object1 toBeforeOpportunity:(GWOpportunity*)object2;
- (void)moveOpportunity:(GWOpportunity*)object1 toAfterOpportunity:(GWOpportunity*)object2;
- (void)swapOpportunity:(GWOpportunity*)object1 withOpportunity:(GWOpportunity*)object2;
- (void)addToOpportunities:(GWOpportunity*)object;
- (void)removeFromOpportunities:(GWOpportunity*)object;


@property(nonatomic,readonly) NSArray* opportunityDumbLists;
@property(nonatomic,readonly) BOOL hasOpportunityDumbListsBeenFaulted;
- (MCPObject*)createAndAddToOpportunityDumbLists;
- (void)faultOpportunityDumbListsAndNotify: (void (^)())block;
- (void)addToOpportunityDumbLists:(MCPObject*)object;
- (void)removeFromOpportunityDumbLists:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* organizations;
@property(nonatomic,readonly) BOOL hasOrganizationsBeenFaulted;
- (GWOrganization*)createAndAddToOrganizations;
- (void)faultOrganizationsAndNotify: (void (^)())block;
- (void)insertOrganization:(GWOrganization*)object atIndex: (NSUInteger)index;
- (void)insertOrganization:(GWOrganization*)object1 beforeOrganization:(GWOrganization*)object2;
- (void)insertOrganization:(GWOrganization*)object1 afterOrganization:(GWOrganization*)object2;
- (void)moveOrganization:(GWOrganization*)object toIndex: (NSUInteger)index;
- (void)moveOrganization:(GWOrganization*)object1 toBeforeOrganization:(GWOrganization*)object2;
- (void)moveOrganization:(GWOrganization*)object1 toAfterOrganization:(GWOrganization*)object2;
- (void)swapOrganization:(GWOrganization*)object1 withOrganization:(GWOrganization*)object2;
- (void)addToOrganizations:(GWOrganization*)object;
- (void)removeFromOrganizations:(GWOrganization*)object;


@property(nonatomic,readonly) NSArray* organizationDumbLists;
@property(nonatomic,readonly) BOOL hasOrganizationDumbListsBeenFaulted;
- (MCPObject*)createAndAddToOrganizationDumbLists;
- (void)faultOrganizationDumbListsAndNotify: (void (^)())block;
- (void)addToOrganizationDumbLists:(MCPObject*)object;
- (void)removeFromOrganizationDumbLists:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* projects;
@property(nonatomic,readonly) BOOL hasProjectsBeenFaulted;
- (GWProject*)createAndAddToProjects;
- (void)faultProjectsAndNotify: (void (^)())block;
- (void)insertProject:(GWProject*)object atIndex: (NSUInteger)index;
- (void)insertProject:(GWProject*)object1 beforeProject:(GWProject*)object2;
- (void)insertProject:(GWProject*)object1 afterProject:(GWProject*)object2;
- (void)moveProject:(GWProject*)object toIndex: (NSUInteger)index;
- (void)moveProject:(GWProject*)object1 toBeforeProject:(GWProject*)object2;
- (void)moveProject:(GWProject*)object1 toAfterProject:(GWProject*)object2;
- (void)swapProject:(GWProject*)object1 withProject:(GWProject*)object2;
- (void)addToProjects:(GWProject*)object;
- (void)removeFromProjects:(GWProject*)object;


@property(nonatomic,readonly) NSArray* projectDumbLists;
@property(nonatomic,readonly) BOOL hasProjectDumbListsBeenFaulted;
- (MCPObject*)createAndAddToProjectDumbLists;
- (void)faultProjectDumbListsAndNotify: (void (^)())block;
- (void)addToProjectDumbLists:(MCPObject*)object;
- (void)removeFromProjectDumbLists:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* groups;
@property(nonatomic,readonly) BOOL hasGroupsBeenFaulted;
- (GWGroup*)createAndAddToGroups;
- (void)faultGroupsAndNotify: (void (^)())block;
- (void)insertGroup:(GWGroup*)object atIndex: (NSUInteger)index;
- (void)insertGroup:(GWGroup*)object1 beforeGroup:(GWGroup*)object2;
- (void)insertGroup:(GWGroup*)object1 afterGroup:(GWGroup*)object2;
- (void)moveGroup:(GWGroup*)object toIndex: (NSUInteger)index;
- (void)moveGroup:(GWGroup*)object1 toBeforeGroup:(GWGroup*)object2;
- (void)moveGroup:(GWGroup*)object1 toAfterGroup:(GWGroup*)object2;
- (void)swapGroup:(GWGroup*)object1 withGroup:(GWGroup*)object2;
- (void)addToGroups:(GWGroup*)object;
- (void)removeFromGroups:(GWGroup*)object;


@property(nonatomic,readonly) NSArray* groupDumbLists;
@property(nonatomic,readonly) BOOL hasGroupDumbListsBeenFaulted;
- (MCPObject*)createAndAddToGroupDumbLists;
- (void)faultGroupDumbListsAndNotify: (void (^)())block;
- (void)addToGroupDumbLists:(MCPObject*)object;
- (void)removeFromGroupDumbLists:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* contacts;
@property(nonatomic,readonly) BOOL hasContactsBeenFaulted;
- (GWContact*)createAndAddToContacts;
- (void)faultContactsAndNotify: (void (^)())block;
- (void)insertContact:(GWContact*)object atIndex: (NSUInteger)index;
- (void)insertContact:(GWContact*)object1 beforeContact:(GWContact*)object2;
- (void)insertContact:(GWContact*)object1 afterContact:(GWContact*)object2;
- (void)moveContact:(GWContact*)object toIndex: (NSUInteger)index;
- (void)moveContact:(GWContact*)object1 toBeforeContact:(GWContact*)object2;
- (void)moveContact:(GWContact*)object1 toAfterContact:(GWContact*)object2;
- (void)swapContact:(GWContact*)object1 withContact:(GWContact*)object2;
- (void)addToContacts:(GWContact*)object;
- (void)removeFromContacts:(GWContact*)object;


@property(nonatomic,readonly) NSArray* contactDumbLists;
@property(nonatomic,readonly) BOOL hasContactDumbListsBeenFaulted;
- (MCPObject*)createAndAddToContactDumbLists;
- (void)faultContactDumbListsAndNotify: (void (^)())block;
- (void)addToContactDumbLists:(MCPObject*)object;
- (void)removeFromContactDumbLists:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* subLists;
@property(nonatomic,readonly) BOOL hasSubListsBeenFaulted;
- (GWSourceList*)createAndAddToSubLists;
- (void)faultSubListsAndNotify: (void (^)())block;
- (void)addToSubLists:(GWSourceList*)object;
- (void)removeFromSubLists:(GWSourceList*)object;


@property(nonatomic,readonly) NSArray* floatingDisplayStates;
@property(nonatomic,readonly) BOOL hasFloatingDisplayStatesBeenFaulted;
- (GWDisplayState*)createAndAddToFloatingDisplayStates;
- (void)faultFloatingDisplayStatesAndNotify: (void (^)())block;
- (void)addToFloatingDisplayStates:(GWDisplayState*)object;
- (void)removeFromFloatingDisplayStates:(GWDisplayState*)object;


@property(nonatomic,readonly) NSArray* displayStates;
@property(nonatomic,readonly) BOOL hasDisplayStatesBeenFaulted;
- (GWDisplayState*)createAndAddToDisplayStates;
- (void)faultDisplayStatesAndNotify: (void (^)())block;
- (void)addToDisplayStates:(GWDisplayState*)object;
- (void)removeFromDisplayStates:(GWDisplayState*)object;




//- (id)initWithCoder:(NSCoder *)decoder;
//- (void)encodeWithCoder:(NSCoder *)coder;

@end
