
// _GWTimeblock.h
// GWSubstrate
//
// Created by eogenerator
// DO NOT EDIT.  Make changes to GWTimeblock.h instead.
//
// Copyright (c) 2001 Marketcircle Inc. All rights reserved.

#import "MCPObject.h"

#import "DLPObject.h"


@class GWSourceList;
@class GWTask;
@class GWUser;
@class GWCustomRecordSet;
@class GWOpportunity;
@class GWVisibilityPreset;
@class GWContact;
@class GWGroup;
@class GWSubscribedCalendar;
@class GWReminder;
@class GWKeyword;
@class GWMeetingInvite;
@class GWRepeatExceptionEntry;
@class GWExtraVInfo;
@class GWEmail;
@class GWConnectorMap;
@class GWTimeblock;
@class GWRepeatRule;
@class GWCalendar;
@class GWLargeData;
@class GWCategory;
@class GWPipelineStage;
@class GWAlertObject;
@class GWTimeblockException;
@class GWNote;
@class GWOrganization;
@class GWBillingRate;
@class GWResource;
@class GWProject;
@class GWRepeatEntry;
@class GWFileAttachment;
@class GWDelegateChainEntry;
@class GWMeetingHistory;

@interface _GWTimeblock : DLPObject
{
}

+ (NSString*)entityName;

#pragma mark -
#pragma mark Attributes

@property(nonatomic,readwrite,strong)NSString *davIdentifier;
@property(nonatomic,readwrite,strong)NSString *caldavResourcePath;
@property(nonatomic,readwrite,strong)NSNumber *externalShowAsBusyTransform;
@property(nonatomic,readwrite,strong)NSNumber *showAsBusy;
@property(nonatomic,readwrite,strong)NSNumber *subscribedCalendarID;
@property(nonatomic,readwrite,strong)NSString *eTag;
@property(nonatomic,readwrite,strong)NSString *writePermissions;
@property(nonatomic,readwrite,strong)NSString *readPermissions;
@property(nonatomic,readwrite,strong)NSString *icsOrganizerAddress;
@property(nonatomic,readwrite,strong)NSDate *icsDateStamp;
@property(nonatomic,readwrite,strong)NSNumber *icsSequence;
@property(nonatomic,readwrite,strong)NSNumber *allDay;
@property(nonatomic,readwrite,strong)NSNumber *visibilityPresetID;
@property(nonatomic,readwrite,strong)NSString *userInviteeSet;
@property(nonatomic,readwrite,strong)NSString *url;
@property(nonatomic,readwrite,strong)NSNumber *typeCode;
@property(nonatomic,readwrite,strong)NSNumber *timeblockID;
@property(nonatomic,readwrite,strong)NSString *timeZoneName;
@property(nonatomic,readwrite,strong)NSString *subject;
@property(nonatomic,readwrite,strong)NSNumber *statusCode;
@property(nonatomic,readwrite,strong)NSDate *startDate;
@property(nonatomic,readwrite,strong)NSString *sourceImportID;
@property(nonatomic,readwrite,strong)NSNumber *sharedDataID;
@property(nonatomic,readwrite,strong)NSNumber *repeatRuleID;
@property(nonatomic,readwrite,strong)NSDate *repeatOriginalDate;
@property(nonatomic,readwrite,strong)NSDate *repeatModifyDate;
@property(nonatomic,readwrite,strong)NSNumber *repeatInterval;
@property(nonatomic,readwrite,strong)NSNumber *repeatFrequency;
@property(nonatomic,readwrite,strong)NSDate *repeatEndDate;
@property(nonatomic,readwrite,strong)NSNumber *repeatCount;
@property(nonatomic,readwrite,strong)NSNumber *repeatByNthDay;
@property(nonatomic,readwrite,strong)NSString *repeatByMonths;
@property(nonatomic,readwrite,strong)NSString *repeatByMonthDays;
@property(nonatomic,readwrite,strong)NSString *repeatByDays;
@property(nonatomic,readwrite,strong)NSNumber *reminderUnits;
@property(nonatomic,readwrite,strong)NSNumber *reminderUnitType;
@property(nonatomic,readwrite,strong)NSDate *reminderFireDate;
@property(nonatomic,readwrite,strong)NSString *rejectedUserInviteeSet;
@property(nonatomic,readwrite,strong)NSNumber *projectID;
@property(nonatomic,readwrite,strong)NSNumber *permissionMask;
@property(nonatomic,readwrite,strong)NSString *pendingUserInviteeSet;
@property(nonatomic,readwrite,strong)NSNumber *parentTimeblockID;
@property(nonatomic,readwrite,strong)NSNumber *ownerID;
@property(nonatomic,readwrite,strong)NSDate *modifyDate;
@property(nonatomic,readwrite,strong)NSNumber *meetingMinutesLargeDataID;
@property(nonatomic,readwrite,strong)NSString *location;
@property(nonatomic,readwrite,strong)NSNumber *isPrivate;
@property(nonatomic,readwrite,strong)NSNumber *isMatchCandidate;
@property(nonatomic,readwrite,strong)NSDate *endDate;
@property(nonatomic,readwrite,strong)NSString *details;
@property(nonatomic,readwrite,strong)NSString *delegateChain;
@property(nonatomic,readwrite,strong)NSNumber *createdByID;
@property(nonatomic,readwrite,strong)NSDate *createDate;
@property(nonatomic,readwrite,strong)NSNumber *categoryID;
@property(nonatomic,readwrite,strong)NSNumber *calendarID;
@property(nonatomic,readwrite,strong)NSNumber *busyCode;
@property(nonatomic,readwrite,strong)NSNumber *billingRateID;
@property(nonatomic,readwrite,strong)NSDate *billedDate;
@property(nonatomic,readwrite,strong)NSNumber *archived;
@property(nonatomic,readwrite,strong)NSString *acceptedUserInviteeSet;



#pragma mark -
#pragma mark To-One Relationships

@property(nonatomic,readwrite,strong)GWSubscribedCalendar* subscribedCalendar;
- (GWSubscribedCalendar*)createAndSetSubscribedCalendarIfNeeded;
- (void)faultSubscribedCalendarAndNotify: (void (^)())block;


@property(nonatomic,readwrite,strong)GWVisibilityPreset* visibilityPreset;
- (GWVisibilityPreset*)createAndSetVisibilityPresetIfNeeded;
- (void)faultVisibilityPresetAndNotify: (void (^)())block;


@property(nonatomic,readwrite,strong)GWTimeblock* repeatParentTimeblock;
- (GWTimeblock*)createAndSetRepeatParentTimeblockIfNeeded;
- (void)faultRepeatParentTimeblockAndNotify: (void (^)())block;


@property(nonatomic,readwrite,strong)GWUser* owner;
- (GWUser*)createAndSetOwnerIfNeeded;
- (void)faultOwnerAndNotify: (void (^)())block;


@property(nonatomic,readwrite,strong)GWLargeData* meetingMinutes;
- (GWLargeData*)createAndSetMeetingMinutesIfNeeded;
- (void)faultMeetingMinutesAndNotify: (void (^)())block;


@property(nonatomic,readwrite,strong)GWRepeatRule* daylite1xRepeatRule;
- (GWRepeatRule*)createAndSetDaylite1xRepeatRuleIfNeeded;
- (void)faultDaylite1xRepeatRuleAndNotify: (void (^)())block;


@property(nonatomic,readwrite,strong)GWUser* createdBy;
- (GWUser*)createAndSetCreatedByIfNeeded;
- (void)faultCreatedByAndNotify: (void (^)())block;


@property(nonatomic,readwrite,strong)GWCategory* category;
- (GWCategory*)createAndSetCategoryIfNeeded;
- (void)faultCategoryAndNotify: (void (^)())block;


@property(nonatomic,readwrite,strong)GWCalendar* calendar;
- (GWCalendar*)createAndSetCalendarIfNeeded;
- (void)faultCalendarAndNotify: (void (^)())block;


@property(nonatomic,readwrite,strong)GWBillingRate* billingRate;
- (GWBillingRate*)createAndSetBillingRateIfNeeded;
- (void)faultBillingRateAndNotify: (void (^)())block;





#pragma mark -
#pragma mark To-Many Relationships

@property(nonatomic,readonly) NSArray* extraVInfos;
@property(nonatomic,readonly) BOOL hasExtraVInfosBeenFaulted;
- (GWExtraVInfo*)createAndAddToExtraVInfos;
- (void)faultExtraVInfosAndNotify: (void (^)())block;
- (void)addToExtraVInfos:(GWExtraVInfo*)object;
- (void)removeFromExtraVInfos:(GWExtraVInfo*)object;


@property(nonatomic,readonly) NSArray* timeblockPipelineStages;
@property(nonatomic,readonly) BOOL hasTimeblockPipelineStagesBeenFaulted;
- (MCPObject*)createAndAddToTimeblockPipelineStages;
- (void)faultTimeblockPipelineStagesAndNotify: (void (^)())block;
- (void)addToTimeblockPipelineStages:(MCPObject*)object;
- (void)removeFromTimeblockPipelineStages:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* pipelineStages;
@property(nonatomic,readonly) BOOL hasPipelineStagesBeenFaulted;
- (GWPipelineStage*)createAndAddToPipelineStages;
- (void)faultPipelineStagesAndNotify: (void (^)())block;
- (void)addToPipelineStages:(GWPipelineStage*)object;
- (void)removeFromPipelineStages:(GWPipelineStage*)object;


@property(nonatomic,readonly) NSArray* alertObjects;
@property(nonatomic,readonly) BOOL hasAlertObjectsBeenFaulted;
- (GWAlertObject*)createAndAddToAlertObjects;
- (void)faultAlertObjectsAndNotify: (void (^)())block;
- (void)addToAlertObjects:(GWAlertObject*)object;
- (void)removeFromAlertObjects:(GWAlertObject*)object;


@property(nonatomic,readonly) NSArray* delegateChainEntries;
@property(nonatomic,readonly) BOOL hasDelegateChainEntriesBeenFaulted;
- (GWDelegateChainEntry*)createAndAddToDelegateChainEntries;
- (void)faultDelegateChainEntriesAndNotify: (void (^)())block;
- (void)insertDelegateChainEntry:(GWDelegateChainEntry*)object atIndex: (NSUInteger)index;
- (void)insertDelegateChainEntry:(GWDelegateChainEntry*)object1 beforeDelegateChainEntry:(GWDelegateChainEntry*)object2;
- (void)insertDelegateChainEntry:(GWDelegateChainEntry*)object1 afterDelegateChainEntry:(GWDelegateChainEntry*)object2;
- (void)moveDelegateChainEntry:(GWDelegateChainEntry*)object toIndex: (NSUInteger)index;
- (void)moveDelegateChainEntry:(GWDelegateChainEntry*)object1 toBeforeDelegateChainEntry:(GWDelegateChainEntry*)object2;
- (void)moveDelegateChainEntry:(GWDelegateChainEntry*)object1 toAfterDelegateChainEntry:(GWDelegateChainEntry*)object2;
- (void)swapDelegateChainEntry:(GWDelegateChainEntry*)object1 withDelegateChainEntry:(GWDelegateChainEntry*)object2;
- (void)addToDelegateChainEntries:(GWDelegateChainEntry*)object;
- (void)removeFromDelegateChainEntries:(GWDelegateChainEntry*)object;


@property(nonatomic,readonly) NSArray* emails;
@property(nonatomic,readonly) BOOL hasEmailsBeenFaulted;
- (GWEmail*)createAndAddToEmails;
- (void)faultEmailsAndNotify: (void (^)())block;
- (void)addToEmails:(GWEmail*)object;
- (void)removeFromEmails:(GWEmail*)object;


@property(nonatomic,readonly) NSArray* timeblockEmails;
@property(nonatomic,readonly) BOOL hasTimeblockEmailsBeenFaulted;
- (MCPObject*)createAndAddToTimeblockEmails;
- (void)faultTimeblockEmailsAndNotify: (void (^)())block;
- (void)addToTimeblockEmails:(MCPObject*)object;
- (void)removeFromTimeblockEmails:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* dumbLists;
@property(nonatomic,readonly) BOOL hasDumbListsBeenFaulted;
- (GWSourceList*)createAndAddToDumbLists;
- (void)faultDumbListsAndNotify: (void (^)())block;
- (void)addToDumbLists:(GWSourceList*)object;
- (void)removeFromDumbLists:(GWSourceList*)object;


@property(nonatomic,readonly) NSArray* timeblockDumbLists;
@property(nonatomic,readonly) BOOL hasTimeblockDumbListsBeenFaulted;
- (MCPObject*)createAndAddToTimeblockDumbLists;
- (void)faultTimeblockDumbListsAndNotify: (void (^)())block;
- (void)addToTimeblockDumbLists:(MCPObject*)object;
- (void)removeFromTimeblockDumbLists:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* tasks;
@property(nonatomic,readonly) BOOL hasTasksBeenFaulted;
- (GWTask*)createAndAddToTasks;
- (void)faultTasksAndNotify: (void (^)())block;
- (void)addToTasks:(GWTask*)object;
- (void)removeFromTasks:(GWTask*)object;


@property(nonatomic,readonly) NSArray* taskTimeblocks;
@property(nonatomic,readonly) BOOL hasTaskTimeblocksBeenFaulted;
- (MCPObject*)createAndAddToTaskTimeblocks;
- (void)faultTaskTimeblocksAndNotify: (void (^)())block;
- (void)addToTaskTimeblocks:(MCPObject*)object;
- (void)removeFromTaskTimeblocks:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* customRecordSets;
@property(nonatomic,readonly) BOOL hasCustomRecordSetsBeenFaulted;
- (GWCustomRecordSet*)createAndAddToCustomRecordSets;
- (void)faultCustomRecordSetsAndNotify: (void (^)())block;
- (void)addToCustomRecordSets:(GWCustomRecordSet*)object;
- (void)removeFromCustomRecordSets:(GWCustomRecordSet*)object;


@property(nonatomic,readonly) NSArray* customRecordSetTimeblocks;
@property(nonatomic,readonly) BOOL hasCustomRecordSetTimeblocksBeenFaulted;
- (MCPObject*)createAndAddToCustomRecordSetTimeblocks;
- (void)faultCustomRecordSetTimeblocksAndNotify: (void (^)())block;
- (void)addToCustomRecordSetTimeblocks:(MCPObject*)object;
- (void)removeFromCustomRecordSetTimeblocks:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* keywords;
@property(nonatomic,readonly) BOOL hasKeywordsBeenFaulted;
- (GWKeyword*)createAndAddToKeywords;
- (void)faultKeywordsAndNotify: (void (^)())block;
- (void)addToKeywords:(GWKeyword*)object;
- (void)removeFromKeywords:(GWKeyword*)object;


@property(nonatomic,readonly) NSArray* keywordTimeblocks;
@property(nonatomic,readonly) BOOL hasKeywordTimeblocksBeenFaulted;
- (MCPObject*)createAndAddToKeywordTimeblocks;
- (void)faultKeywordTimeblocksAndNotify: (void (^)())block;
- (void)addToKeywordTimeblocks:(MCPObject*)object;
- (void)removeFromKeywordTimeblocks:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* notes;
@property(nonatomic,readonly) BOOL hasNotesBeenFaulted;
- (GWNote*)createAndAddToNotes;
- (void)faultNotesAndNotify: (void (^)())block;
- (void)addToNotes:(GWNote*)object;
- (void)removeFromNotes:(GWNote*)object;


@property(nonatomic,readonly) NSArray* noteTimeblocks;
@property(nonatomic,readonly) BOOL hasNoteTimeblocksBeenFaulted;
- (MCPObject*)createAndAddToNoteTimeblocks;
- (void)faultNoteTimeblocksAndNotify: (void (^)())block;
- (void)addToNoteTimeblocks:(MCPObject*)object;
- (void)removeFromNoteTimeblocks:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* fileAttachments;
@property(nonatomic,readonly) BOOL hasFileAttachmentsBeenFaulted;
- (GWFileAttachment*)createAndAddToFileAttachments;
- (void)faultFileAttachmentsAndNotify: (void (^)())block;
- (void)addToFileAttachments:(GWFileAttachment*)object;
- (void)removeFromFileAttachments:(GWFileAttachment*)object;


@property(nonatomic,readonly) NSArray* meetingInvites;
@property(nonatomic,readonly) BOOL hasMeetingInvitesBeenFaulted;
- (GWMeetingInvite*)createAndAddToMeetingInvites;
- (void)faultMeetingInvitesAndNotify: (void (^)())block;
- (void)addToMeetingInvites:(GWMeetingInvite*)object;
- (void)removeFromMeetingInvites:(GWMeetingInvite*)object;


@property(nonatomic,readonly) NSArray* resources;
@property(nonatomic,readonly) BOOL hasResourcesBeenFaulted;
- (GWResource*)createAndAddToResources;
- (void)faultResourcesAndNotify: (void (^)())block;
- (void)addToResources:(GWResource*)object;
- (void)removeFromResources:(GWResource*)object;


@property(nonatomic,readonly) NSArray* resourceTimeblocksJoin;
@property(nonatomic,readonly) BOOL hasResourceTimeblocksJoinBeenFaulted;
- (MCPObject*)createAndAddToResourceTimeblocksJoin;
- (void)faultResourceTimeblocksJoinAndNotify: (void (^)())block;
- (void)addToResourceTimeblocksJoin:(MCPObject*)object;
- (void)removeFromResourceTimeblocksJoin:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* repeatExceptions;
@property(nonatomic,readonly) BOOL hasRepeatExceptionsBeenFaulted;
- (GWTimeblockException*)createAndAddToRepeatExceptions;
- (void)faultRepeatExceptionsAndNotify: (void (^)())block;
- (void)addToRepeatExceptions:(GWTimeblockException*)object;
- (void)removeFromRepeatExceptions:(GWTimeblockException*)object;


@property(nonatomic,readonly) NSArray* repeatExceptionTimeblocks;
@property(nonatomic,readonly) BOOL hasRepeatExceptionTimeblocksBeenFaulted;
- (GWTimeblock*)createAndAddToRepeatExceptionTimeblocks;
- (void)faultRepeatExceptionTimeblocksAndNotify: (void (^)())block;
- (void)addToRepeatExceptionTimeblocks:(GWTimeblock*)object;
- (void)removeFromRepeatExceptionTimeblocks:(GWTimeblock*)object;


@property(nonatomic,readonly) NSArray* repeatExceptionEntries;
@property(nonatomic,readonly) BOOL hasRepeatExceptionEntriesBeenFaulted;
- (GWRepeatExceptionEntry*)createAndAddToRepeatExceptionEntries;
- (void)faultRepeatExceptionEntriesAndNotify: (void (^)())block;
- (void)addToRepeatExceptionEntries:(GWRepeatExceptionEntry*)object;
- (void)removeFromRepeatExceptionEntries:(GWRepeatExceptionEntry*)object;


@property(nonatomic,readonly) NSArray* repeatEntries;
@property(nonatomic,readonly) BOOL hasRepeatEntriesBeenFaulted;
- (GWRepeatEntry*)createAndAddToRepeatEntries;
- (void)faultRepeatEntriesAndNotify: (void (^)())block;
- (void)addToRepeatEntries:(GWRepeatEntry*)object;
- (void)removeFromRepeatEntries:(GWRepeatEntry*)object;


@property(nonatomic,readonly) NSArray* reminders;
@property(nonatomic,readonly) BOOL hasRemindersBeenFaulted;
- (GWReminder*)createAndAddToReminders;
- (void)faultRemindersAndNotify: (void (^)())block;
- (void)addToReminders:(GWReminder*)object;
- (void)removeFromReminders:(GWReminder*)object;


@property(nonatomic,readonly) NSArray* projects;
@property(nonatomic,readonly) BOOL hasProjectsBeenFaulted;
- (GWProject*)createAndAddToProjects;
- (void)faultProjectsAndNotify: (void (^)())block;
- (void)addToProjects:(GWProject*)object;
- (void)removeFromProjects:(GWProject*)object;


@property(nonatomic,readonly) NSArray* projectTimeblocks;
@property(nonatomic,readonly) BOOL hasProjectTimeblocksBeenFaulted;
- (MCPObject*)createAndAddToProjectTimeblocks;
- (void)faultProjectTimeblocksAndNotify: (void (^)())block;
- (void)addToProjectTimeblocks:(MCPObject*)object;
- (void)removeFromProjectTimeblocks:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* organizations;
@property(nonatomic,readonly) BOOL hasOrganizationsBeenFaulted;
- (GWOrganization*)createAndAddToOrganizations;
- (void)faultOrganizationsAndNotify: (void (^)())block;
- (void)addToOrganizations:(GWOrganization*)object;
- (void)removeFromOrganizations:(GWOrganization*)object;


@property(nonatomic,readonly) NSArray* organizationTimeblocks;
@property(nonatomic,readonly) BOOL hasOrganizationTimeblocksBeenFaulted;
- (MCPObject*)createAndAddToOrganizationTimeblocks;
- (void)faultOrganizationTimeblocksAndNotify: (void (^)())block;
- (void)addToOrganizationTimeblocks:(MCPObject*)object;
- (void)removeFromOrganizationTimeblocks:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* opportunityTimeblocks;
@property(nonatomic,readonly) BOOL hasOpportunityTimeblocksBeenFaulted;
- (MCPObject*)createAndAddToOpportunityTimeblocks;
- (void)faultOpportunityTimeblocksAndNotify: (void (^)())block;
- (void)addToOpportunityTimeblocks:(MCPObject*)object;
- (void)removeFromOpportunityTimeblocks:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* opportunities;
@property(nonatomic,readonly) BOOL hasOpportunitiesBeenFaulted;
- (GWOpportunity*)createAndAddToOpportunities;
- (void)faultOpportunitiesAndNotify: (void (^)())block;
- (void)addToOpportunities:(GWOpportunity*)object;
- (void)removeFromOpportunities:(GWOpportunity*)object;


@property(nonatomic,readonly) NSArray* meetingHistories;
@property(nonatomic,readonly) BOOL hasMeetingHistoriesBeenFaulted;
- (GWMeetingHistory*)createAndAddToMeetingHistories;
- (void)faultMeetingHistoriesAndNotify: (void (^)())block;
- (void)addToMeetingHistories:(GWMeetingHistory*)object;
- (void)removeFromMeetingHistories:(GWMeetingHistory*)object;


@property(nonatomic,readonly) NSArray* groups;
@property(nonatomic,readonly) BOOL hasGroupsBeenFaulted;
- (GWGroup*)createAndAddToGroups;
- (void)faultGroupsAndNotify: (void (^)())block;
- (void)addToGroups:(GWGroup*)object;
- (void)removeFromGroups:(GWGroup*)object;


@property(nonatomic,readonly) NSArray* groupTimeblocks;
@property(nonatomic,readonly) BOOL hasGroupTimeblocksBeenFaulted;
- (MCPObject*)createAndAddToGroupTimeblocks;
- (void)faultGroupTimeblocksAndNotify: (void (^)())block;
- (void)addToGroupTimeblocks:(MCPObject*)object;
- (void)removeFromGroupTimeblocks:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* contacts;
@property(nonatomic,readonly) BOOL hasContactsBeenFaulted;
- (GWContact*)createAndAddToContacts;
- (void)faultContactsAndNotify: (void (^)())block;
- (void)addToContacts:(GWContact*)object;
- (void)removeFromContacts:(GWContact*)object;


@property(nonatomic,readonly) NSArray* contactTimeblocks;
@property(nonatomic,readonly) BOOL hasContactTimeblocksBeenFaulted;
- (MCPObject*)createAndAddToContactTimeblocks;
- (void)faultContactTimeblocksAndNotify: (void (^)())block;
- (void)addToContactTimeblocks:(MCPObject*)object;
- (void)removeFromContactTimeblocks:(MCPObject*)object;


@property(nonatomic,readonly) NSArray* connectorMaps;
@property(nonatomic,readonly) BOOL hasConnectorMapsBeenFaulted;
- (GWConnectorMap*)createAndAddToConnectorMaps;
- (void)faultConnectorMapsAndNotify: (void (^)())block;
- (void)addToConnectorMaps:(GWConnectorMap*)object;
- (void)removeFromConnectorMaps:(GWConnectorMap*)object;




//- (id)initWithCoder:(NSCoder *)decoder;
//- (void)encodeWithCoder:(NSCoder *)coder;

@end
